/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 31 "filter/grammar.y"


#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <stdint.h>
#include <string.h>
#include <stdarg.h>
#include <inttypes.h>
#include <stdlib.h>
#include <stddef.h>
#include <errno.h>
#include <ctype.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "filter.h"
#include "userio.h"
#include "nfxV3.h"
#include "ipconv.h"
#include "sgregex.h"
#include "ja3/ja3.h"
#include "ja4/ja4.h"
#include "nfdump.h"
#include "util.h"

#define AnyMask 0xffffffffffffffffLL

const data_t NULLPtr = {NULL};

/*
 * function prototypes
 */
static void yyerror(char *msg);

/* var defs */
extern int 			lineno;
extern char 		*yytext;
extern uint32_t	StartNode;
extern char *FilterFilename;

static ipStack_t ipStack[MAXHOSTS];

static uint32_t ChainHosts(ipStack_t *ipStack, int numIP, int direction);

static int AddIdent(char *ident);

static int AddEngineNum(char *type, uint16_t comp, uint64_t num);

static int AddExporterNum(char *type, uint16_t comp, uint64_t num);

static int AddProto(direction_t direction, char *protoStr, uint64_t protoNum);

static int AddPortNumber(direction_t direction, uint16_t comp, uint64_t port);

static int AddICMP(char *type, uint16_t comp, uint64_t number);

static int AddAsNumber(direction_t direction, uint16_t comp, uint64_t as);

static int AddFlagsNumber(direction_t direction, uint16_t comp, uint64_t flags);

static int AddFlagsString(direction_t direction, char *flags);

static int AddTosNumber(direction_t direction, uint16_t comp, uint64_t tos);

static int AddIPttl(prefix_t prefix, uint16_t comp, uint64_t ttl);

static int AddIPttlEqual(char *arg);

static int AddPackets(direction_t direction, uint16_t comp, uint64_t packets);

static int AddBytes(direction_t direction, uint16_t comp, uint64_t bytes);

static int AddFwdStatNum(uint16_t comp, uint64_t num);

static int AddFwdStatString(char *string);

static int AddIP(direction_t direction, char *IPstr);

static int AddIPlist(direction_t direction, void *IPstr);

static int AddNet(direction_t direction, char *IPstr, char *maskStr);

static int AddNetPrefix(direction_t direction, char *IPstr, uint64_t mask);

static int AddInterfaceNumber(direction_t direction, uint64_t num);

static int AddVlanNumber(direction_t direction, uint64_t num);

static int AddMaskNumber(direction_t direction, uint64_t num);

static int AddFlowDir(direction_t direction, int64_t dirNum);

static int AddMPLS(char *type, uint16_t comp, uint64_t value);

static int AddMAC(direction_t direction, char *macString);

static int AddEthertype(uint64_t etherType);

static int AddLatency(direction_t direction, uint16_t comp, uint64_t number);

static int AddASAString(char *event, char *asaStr);

static int AddASA(char *event, uint16_t comp, uint64_t number);

static int AddASApblock(direction_t direction, char *arg);

static int AddNATString(char *event, char *asaStr);

static int AddNAT(char *event, uint16_t comp, uint64_t number);

static int AddNatPortBlocks(char *type, char *subtype, uint16_t comp, uint64_t number);

static int AddACL(direction_t direction, uint16_t comp, uint64_t number);

static int AddPayload(char *type, char *arg, char *opt);

static int AddGeo(direction_t direction, char *geo);

static int AddObservation(char *type, char *subType, uint16_t comp, uint64_t number);

static int AddVRF(direction_t direction, uint16_t comp, uint64_t number);

static int AddTimeSting(char *firstLast, uint16_t comp, char *timeString);

static int AddPFString(char *type, char *arg);

static int AddPFNumber(char *type, uint16_t comp, uint64_t number);

static void *NewIplist(char *IPstr, int prefix);

static void *NewU64list(uint64_t num);

static int InsertIPlist(void *IPlist, char *IPstr, int64_t prefix);

static int InsertU64list(void *U64list, uint64_t num);

static int AddPortList(direction_t direction, void *U64List);

static int AddASList(direction_t direction, void *U64List);


#line 214 "filter/grammar.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_FILTER_GRAMMAR_H_INCLUDED
# define YY_YY_FILTER_GRAMMAR_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    EQ = 258,                      /* EQ  */
    LT = 259,                      /* LT  */
    GT = 260,                      /* GT  */
    LE = 261,                      /* LE  */
    GE = 262,                      /* GE  */
    ANY = 263,                     /* ANY  */
    NOT = 264,                     /* NOT  */
    IDENT = 265,                   /* IDENT  */
    COUNT = 266,                   /* COUNT  */
    IP = 267,                      /* IP  */
    IPV4 = 268,                    /* IPV4  */
    IPV6 = 269,                    /* IPV6  */
    IPTTL = 270,                   /* IPTTL  */
    NET = 271,                     /* NET  */
    SRC = 272,                     /* SRC  */
    DST = 273,                     /* DST  */
    IN = 274,                      /* IN  */
    OUT = 275,                     /* OUT  */
    MIN = 276,                     /* MIN  */
    MAX = 277,                     /* MAX  */
    PREV = 278,                    /* PREV  */
    NEXT = 279,                    /* NEXT  */
    BGP = 280,                     /* BGP  */
    ROUTER = 281,                  /* ROUTER  */
    INGRESS = 282,                 /* INGRESS  */
    EGRESS = 283,                  /* EGRESS  */
    CLIENT = 284,                  /* CLIENT  */
    SERVER = 285,                  /* SERVER  */
    NAT = 286,                     /* NAT  */
    XLATE = 287,                   /* XLATE  */
    TUN = 288,                     /* TUN  */
    ENGINE = 289,                  /* ENGINE  */
    ENGINETYPE = 290,              /* ENGINETYPE  */
    ENGINEID = 291,                /* ENGINEID  */
    EXPORTER = 292,                /* EXPORTER  */
    DURATION = 293,                /* DURATION  */
    PPS = 294,                     /* PPS  */
    BPS = 295,                     /* BPS  */
    BPP = 296,                     /* BPP  */
    FLAGS = 297,                   /* FLAGS  */
    PROTO = 298,                   /* PROTO  */
    PORT = 299,                    /* PORT  */
    AS = 300,                      /* AS  */
    IF = 301,                      /* IF  */
    VLAN = 302,                    /* VLAN  */
    MPLS = 303,                    /* MPLS  */
    MAC = 304,                     /* MAC  */
    ICMP = 305,                    /* ICMP  */
    ICMPTYPE = 306,                /* ICMPTYPE  */
    ICMPCODE = 307,                /* ICMPCODE  */
    PACKETS = 308,                 /* PACKETS  */
    BYTES = 309,                   /* BYTES  */
    FLOWS = 310,                   /* FLOWS  */
    ETHERTYPE = 311,               /* ETHERTYPE  */
    MASK = 312,                    /* MASK  */
    FLOWDIR = 313,                 /* FLOWDIR  */
    TOS = 314,                     /* TOS  */
    FWDSTAT = 315,                 /* FWDSTAT  */
    LATENCY = 316,                 /* LATENCY  */
    ASA = 317,                     /* ASA  */
    ACL = 318,                     /* ACL  */
    PAYLOAD = 319,                 /* PAYLOAD  */
    VRF = 320,                     /* VRF  */
    OBSERVATION = 321,             /* OBSERVATION  */
    PF = 322,                      /* PF  */
    SEEN = 323,                    /* SEEN  */
    STRING = 324,                  /* STRING  */
    GEOSTRING = 325,               /* GEOSTRING  */
    NUMBER = 326,                  /* NUMBER  */
    OR = 327,                      /* OR  */
    AND = 328,                     /* AND  */
    NEGATE = 329                   /* NEGATE  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define EQ 258
#define LT 259
#define GT 260
#define LE 261
#define GE 262
#define ANY 263
#define NOT 264
#define IDENT 265
#define COUNT 266
#define IP 267
#define IPV4 268
#define IPV6 269
#define IPTTL 270
#define NET 271
#define SRC 272
#define DST 273
#define IN 274
#define OUT 275
#define MIN 276
#define MAX 277
#define PREV 278
#define NEXT 279
#define BGP 280
#define ROUTER 281
#define INGRESS 282
#define EGRESS 283
#define CLIENT 284
#define SERVER 285
#define NAT 286
#define XLATE 287
#define TUN 288
#define ENGINE 289
#define ENGINETYPE 290
#define ENGINEID 291
#define EXPORTER 292
#define DURATION 293
#define PPS 294
#define BPS 295
#define BPP 296
#define FLAGS 297
#define PROTO 298
#define PORT 299
#define AS 300
#define IF 301
#define VLAN 302
#define MPLS 303
#define MAC 304
#define ICMP 305
#define ICMPTYPE 306
#define ICMPCODE 307
#define PACKETS 308
#define BYTES 309
#define FLOWS 310
#define ETHERTYPE 311
#define MASK 312
#define FLOWDIR 313
#define TOS 314
#define FWDSTAT 315
#define LATENCY 316
#define ASA 317
#define ACL 318
#define PAYLOAD 319
#define VRF 320
#define OBSERVATION 321
#define PF 322
#define SEEN 323
#define STRING 324
#define GEOSTRING 325
#define NUMBER 326
#define OR 327
#define AND 328
#define NEGATE 329

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 174 "filter/grammar.y"

	uint64_t			value;
	char					*s;
	FilterParam_t	param;
	void					*list;

#line 422 "filter/grammar.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_FILTER_GRAMMAR_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_EQ = 3,                         /* EQ  */
  YYSYMBOL_LT = 4,                         /* LT  */
  YYSYMBOL_GT = 5,                         /* GT  */
  YYSYMBOL_LE = 6,                         /* LE  */
  YYSYMBOL_GE = 7,                         /* GE  */
  YYSYMBOL_ANY = 8,                        /* ANY  */
  YYSYMBOL_NOT = 9,                        /* NOT  */
  YYSYMBOL_IDENT = 10,                     /* IDENT  */
  YYSYMBOL_COUNT = 11,                     /* COUNT  */
  YYSYMBOL_IP = 12,                        /* IP  */
  YYSYMBOL_IPV4 = 13,                      /* IPV4  */
  YYSYMBOL_IPV6 = 14,                      /* IPV6  */
  YYSYMBOL_IPTTL = 15,                     /* IPTTL  */
  YYSYMBOL_NET = 16,                       /* NET  */
  YYSYMBOL_SRC = 17,                       /* SRC  */
  YYSYMBOL_DST = 18,                       /* DST  */
  YYSYMBOL_IN = 19,                        /* IN  */
  YYSYMBOL_OUT = 20,                       /* OUT  */
  YYSYMBOL_MIN = 21,                       /* MIN  */
  YYSYMBOL_MAX = 22,                       /* MAX  */
  YYSYMBOL_PREV = 23,                      /* PREV  */
  YYSYMBOL_NEXT = 24,                      /* NEXT  */
  YYSYMBOL_BGP = 25,                       /* BGP  */
  YYSYMBOL_ROUTER = 26,                    /* ROUTER  */
  YYSYMBOL_INGRESS = 27,                   /* INGRESS  */
  YYSYMBOL_EGRESS = 28,                    /* EGRESS  */
  YYSYMBOL_CLIENT = 29,                    /* CLIENT  */
  YYSYMBOL_SERVER = 30,                    /* SERVER  */
  YYSYMBOL_NAT = 31,                       /* NAT  */
  YYSYMBOL_XLATE = 32,                     /* XLATE  */
  YYSYMBOL_TUN = 33,                       /* TUN  */
  YYSYMBOL_ENGINE = 34,                    /* ENGINE  */
  YYSYMBOL_ENGINETYPE = 35,                /* ENGINETYPE  */
  YYSYMBOL_ENGINEID = 36,                  /* ENGINEID  */
  YYSYMBOL_EXPORTER = 37,                  /* EXPORTER  */
  YYSYMBOL_DURATION = 38,                  /* DURATION  */
  YYSYMBOL_PPS = 39,                       /* PPS  */
  YYSYMBOL_BPS = 40,                       /* BPS  */
  YYSYMBOL_BPP = 41,                       /* BPP  */
  YYSYMBOL_FLAGS = 42,                     /* FLAGS  */
  YYSYMBOL_PROTO = 43,                     /* PROTO  */
  YYSYMBOL_PORT = 44,                      /* PORT  */
  YYSYMBOL_AS = 45,                        /* AS  */
  YYSYMBOL_IF = 46,                        /* IF  */
  YYSYMBOL_VLAN = 47,                      /* VLAN  */
  YYSYMBOL_MPLS = 48,                      /* MPLS  */
  YYSYMBOL_MAC = 49,                       /* MAC  */
  YYSYMBOL_ICMP = 50,                      /* ICMP  */
  YYSYMBOL_ICMPTYPE = 51,                  /* ICMPTYPE  */
  YYSYMBOL_ICMPCODE = 52,                  /* ICMPCODE  */
  YYSYMBOL_PACKETS = 53,                   /* PACKETS  */
  YYSYMBOL_BYTES = 54,                     /* BYTES  */
  YYSYMBOL_FLOWS = 55,                     /* FLOWS  */
  YYSYMBOL_ETHERTYPE = 56,                 /* ETHERTYPE  */
  YYSYMBOL_MASK = 57,                      /* MASK  */
  YYSYMBOL_FLOWDIR = 58,                   /* FLOWDIR  */
  YYSYMBOL_TOS = 59,                       /* TOS  */
  YYSYMBOL_FWDSTAT = 60,                   /* FWDSTAT  */
  YYSYMBOL_LATENCY = 61,                   /* LATENCY  */
  YYSYMBOL_ASA = 62,                       /* ASA  */
  YYSYMBOL_ACL = 63,                       /* ACL  */
  YYSYMBOL_PAYLOAD = 64,                   /* PAYLOAD  */
  YYSYMBOL_VRF = 65,                       /* VRF  */
  YYSYMBOL_OBSERVATION = 66,               /* OBSERVATION  */
  YYSYMBOL_PF = 67,                        /* PF  */
  YYSYMBOL_SEEN = 68,                      /* SEEN  */
  YYSYMBOL_STRING = 69,                    /* STRING  */
  YYSYMBOL_GEOSTRING = 70,                 /* GEOSTRING  */
  YYSYMBOL_NUMBER = 71,                    /* NUMBER  */
  YYSYMBOL_72_ = 72,                       /* '+'  */
  YYSYMBOL_OR = 73,                        /* OR  */
  YYSYMBOL_74_ = 74,                       /* '*'  */
  YYSYMBOL_AND = 75,                       /* AND  */
  YYSYMBOL_NEGATE = 76,                    /* NEGATE  */
  YYSYMBOL_77_ = 77,                       /* '/'  */
  YYSYMBOL_78_ = 78,                       /* '['  */
  YYSYMBOL_79_ = 79,                       /* ']'  */
  YYSYMBOL_80_ = 80,                       /* ','  */
  YYSYMBOL_81_ = 81,                       /* '('  */
  YYSYMBOL_82_ = 82,                       /* ')'  */
  YYSYMBOL_YYACCEPT = 83,                  /* $accept  */
  YYSYMBOL_prog = 84,                      /* prog  */
  YYSYMBOL_term = 85,                      /* term  */
  YYSYMBOL_iplist = 86,                    /* iplist  */
  YYSYMBOL_u64list = 87,                   /* u64list  */
  YYSYMBOL_comp = 88,                      /* comp  */
  YYSYMBOL_dqual = 89,                     /* dqual  */
  YYSYMBOL_minmax = 90,                    /* minmax  */
  YYSYMBOL_expr = 91                       /* expr  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  95
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   406

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  83
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  9
/* YYNRULES -- Number of rules.  */
#define YYNRULES  115
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  223

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   329


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      81,    82,    74,    72,    80,     2,     2,    77,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    78,     2,    79,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    73,    75,    76
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   206,   206,   207,   212,   217,   221,   225,   229,   233,
     237,   241,   245,   249,   253,   257,   261,   265,   269,   273,
     277,   281,   285,   289,   293,   297,   301,   305,   309,   313,
     317,   321,   325,   329,   333,   337,   341,   345,   349,   353,
     357,   361,   365,   369,   373,   377,   381,   385,   389,   393,
     408,   412,   416,   420,   424,   428,   432,   436,   440,   444,
     448,   452,   456,   463,   467,   471,   489,   493,   497,   503,
     507,   511,   515,   519,   523,   528,   532,   536,   542,   543,
     544,   545,   546,   547,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   577,   578,
     579,   582,   583,   584,   585,   586
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "EQ", "LT", "GT", "LE",
  "GE", "ANY", "NOT", "IDENT", "COUNT", "IP", "IPV4", "IPV6", "IPTTL",
  "NET", "SRC", "DST", "IN", "OUT", "MIN", "MAX", "PREV", "NEXT", "BGP",
  "ROUTER", "INGRESS", "EGRESS", "CLIENT", "SERVER", "NAT", "XLATE", "TUN",
  "ENGINE", "ENGINETYPE", "ENGINEID", "EXPORTER", "DURATION", "PPS", "BPS",
  "BPP", "FLAGS", "PROTO", "PORT", "AS", "IF", "VLAN", "MPLS", "MAC",
  "ICMP", "ICMPTYPE", "ICMPCODE", "PACKETS", "BYTES", "FLOWS", "ETHERTYPE",
  "MASK", "FLOWDIR", "TOS", "FWDSTAT", "LATENCY", "ASA", "ACL", "PAYLOAD",
  "VRF", "OBSERVATION", "PF", "SEEN", "STRING", "GEOSTRING", "NUMBER",
  "'+'", "OR", "'*'", "AND", "NEGATE", "'/'", "'['", "']'", "','", "'('",
  "')'", "$accept", "prog", "term", "iplist", "u64list", "comp", "dqual",
  "minmax", "expr", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-27)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-109)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     113,   -27,   178,   -14,   102,   -27,   -27,    42,    65,     3,
      33,   -27,   -27,   -27,   -27,    32,   -27,   -27,   -27,   -27,
     -27,    -7,   -27,    11,   102,   102,    22,   102,   102,   102,
     102,    -6,    28,   102,   102,   102,   -26,   335,    19,    47,
      49,    56,    60,    34,   178,    90,   -27,   276,    96,    37,
     -27,   -27,   -27,   -27,   -27,   -27,   -27,    74,   -27,   -27,
     -27,   -27,   -27,   -27,   -27,   -27,   -27,    25,   102,    84,
      91,   102,    95,    99,   103,   105,   102,   102,   102,   107,
     110,   112,   -27,   -27,   -27,   -27,   -27,   -27,   114,   245,
      98,   115,   280,   102,   -16,   -27,   -11,   121,    30,   -23,
     153,   218,   139,   149,   158,   102,   102,   160,   102,   102,
     102,   102,   -27,    35,   178,   178,   -27,    12,   161,   164,
     -27,   -27,   168,   -27,   -27,   -27,   -27,   170,   172,   175,
     -27,   -27,   -27,   -27,   -27,   182,   -27,   185,   102,   -27,
     184,   -27,    46,   -27,   179,   -27,    26,   -27,   187,   -27,
     -27,   -27,   -18,   189,   183,   195,   -27,   -27,   -27,   196,
     206,   -27,   208,   209,   210,   219,   -27,   220,   181,   -27,
     222,   -27,   -27,   -27,   -27,   -27,   -27,   -27,   -27,   223,
     -27,   -27,   -27,   226,   -27,   225,   -27,   232,   231,   -27,
     231,   -27,   -27,   -27,   -27,   -27,   -27,   -27,   -27,   -27,
     -27,   212,    -8,   -27,   -27,   -27,    -1,    21,   241,   238,
     -27,   255,   -27,   -27,   256,   -27,   -27,   257,   249,   -27,
     -27,   260,   -27
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
      84,     4,    84,     0,    78,     5,     6,    85,    86,    93,
      94,   109,   110,   103,   104,     0,   106,    99,   100,   101,
     102,    91,    92,     0,    78,    78,   107,    78,    78,    78,
      78,     0,     0,    78,    78,    78,     0,    84,    78,     0,
       0,     0,     0,     0,    84,     0,   111,     0,     0,     3,
     114,     7,    79,    80,    81,    82,    83,     0,    87,    89,
      88,    90,    95,    96,    97,    98,   105,    78,    78,     0,
       0,    78,     0,     0,     0,     0,    78,    78,    78,     0,
       0,     0,    41,    91,   107,    42,    43,    26,     0,    84,
       0,     0,    84,    78,     0,     1,     0,     0,    78,     0,
      78,    78,     0,     0,     0,    78,    78,     0,    78,    78,
      78,    78,    58,    78,    84,    84,     8,    53,     0,     0,
       9,    10,     0,    27,    28,    29,    30,     0,     0,     0,
      17,    18,    32,    25,    48,     0,    49,    56,    78,    63,
       0,    65,     0,   115,     0,    34,     0,    21,     0,    15,
      14,    13,     0,     0,     0,     0,    37,    38,    46,     0,
       0,    40,     0,     0,     0,     0,    24,     0,   112,   113,
       0,    55,    11,    12,    45,    44,    19,    50,    57,     0,
      64,    61,    62,     0,    35,     0,    20,     0,     0,    16,
       0,    39,    31,    33,    22,    47,    52,    60,    23,    54,
      59,    69,     0,    36,    51,    75,     0,     0,     0,    71,
      66,     0,    76,    67,     0,    68,    70,     0,    72,    77,
      73,     0,    74
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -27,   -27,   -27,   -27,   142,   -24,   -25,   -27,     5
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,    45,    46,   202,   206,    57,    47,    48,    49
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      69,    70,    76,    72,    73,    74,    75,    50,   144,    79,
      80,    81,    86,   187,    88,    52,    53,    54,    55,    56,
      62,    63,    52,    53,    54,    55,    56,   149,    52,    53,
      54,    55,    56,    52,    53,    54,    55,    56,    52,    53,
      54,    55,    56,   118,   119,    82,   150,   122,   151,    94,
      64,    65,   127,   128,   129,    51,    66,   114,   145,   115,
     188,   209,    67,    77,   136,   135,   143,   141,   140,   142,
     212,   210,   211,    58,   148,    59,   153,   155,   213,   214,
      68,   159,   160,   -78,   162,   163,   164,   165,    87,   167,
      95,    71,   212,   170,   117,   184,    60,    78,    61,   147,
     215,   214,    93,   185,   166,    52,    53,    54,    55,    56,
     114,   113,   115,    -2,   179,   181,    89,   182,    90,   168,
     169,     1,     2,     3,     4,    91,     5,     6,  -108,    92,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,   116,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   120,    52,    53,    54,    55,
      56,    31,   121,    32,    33,    34,   123,   137,    35,    36,
     124,    37,   152,    38,   125,    39,   126,    40,   130,    41,
      42,   131,    43,   132,   138,   133,     1,     2,     3,     4,
     146,     5,     6,  -108,    44,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
     156,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     157,    52,    53,    54,    55,    56,    31,   158,    32,    33,
      34,   161,   171,    35,    36,   172,    37,   154,    38,   173,
      39,   174,    40,   175,    41,    42,   176,    43,    52,    53,
      54,    55,    56,   177,   178,   180,   115,   183,   186,    44,
     189,   190,     7,     8,     9,    10,   191,   192,    13,    14,
      15,    16,    17,    18,    19,    20,    83,   193,    22,   194,
     195,   196,    84,    52,    53,    54,    55,    56,    96,   208,
     197,   198,    97,   199,   200,   201,   203,     7,     8,     9,
      10,   204,   205,    13,    14,    15,    16,    17,    18,    19,
      20,    83,   216,    22,   134,   217,   -78,    84,    98,    99,
     100,   101,   102,   103,   218,   104,   221,   219,   220,   105,
     106,   222,   207,   107,     0,   108,     0,   109,     0,   110,
       0,   111,     0,     0,     0,     0,   112,     0,     0,   139,
       0,   -78,     7,     8,     9,    10,     0,     0,    13,    14,
      15,    16,    17,    18,    19,    20,    83,     0,    22,     0,
       0,     0,    84,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    85
};

static const yytype_int16 yycheck[] =
{
      24,    25,     8,    27,    28,    29,    30,     2,    19,    33,
      34,    35,    37,    31,    38,     3,     4,     5,     6,     7,
      17,    18,     3,     4,     5,     6,     7,    50,     3,     4,
       5,     6,     7,     3,     4,     5,     6,     7,     3,     4,
       5,     6,     7,    67,    68,    71,    69,    71,    71,    44,
      17,    18,    76,    77,    78,    69,    24,    73,    69,    75,
      78,    69,    69,    69,    89,    89,    82,    92,    92,    93,
      71,    79,    80,    31,    98,    33,   100,   101,    79,    80,
      69,   105,   106,    71,   108,   109,   110,   111,    69,   113,
       0,    69,    71,   117,    69,    69,    31,    69,    33,    69,
      79,    80,    68,    77,    69,     3,     4,     5,     6,     7,
      73,    15,    75,     0,   138,    69,    69,    71,    69,   114,
     115,     8,     9,    10,    11,    69,    13,    14,    15,    69,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    71,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    71,     3,     4,     5,     6,
       7,    48,    71,    50,    51,    52,    71,    69,    55,    56,
      71,    58,    19,    60,    71,    62,    71,    64,    71,    66,
      67,    71,    69,    71,    69,    71,     8,     9,    10,    11,
      69,    13,    14,    15,    81,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      71,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      71,     3,     4,     5,     6,     7,    48,    69,    50,    51,
      52,    71,    71,    55,    56,    71,    58,    19,    60,    71,
      62,    71,    64,    71,    66,    67,    71,    69,     3,     4,
       5,     6,     7,    71,    69,    71,    75,    78,    71,    81,
      71,    78,    17,    18,    19,    20,    71,    71,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    71,    33,    71,
      71,    71,    37,     3,     4,     5,     6,     7,    12,    77,
      71,    71,    16,    71,    71,    69,    71,    17,    18,    19,
      20,    69,    71,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    71,    33,    69,    77,    71,    37,    42,    43,
      44,    45,    46,    47,    69,    49,    77,    71,    71,    53,
      54,    71,   190,    57,    -1,    59,    -1,    61,    -1,    63,
      -1,    65,    -1,    -1,    -1,    -1,    70,    -1,    -1,    69,
      -1,    71,    17,    18,    19,    20,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    33,    -1,
      -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    71
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     8,     9,    10,    11,    13,    14,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    48,    50,    51,    52,    55,    56,    58,    60,    62,
      64,    66,    67,    69,    81,    84,    85,    89,    90,    91,
      91,    69,     3,     4,     5,     6,     7,    88,    31,    33,
      31,    33,    17,    18,    17,    18,    24,    69,    69,    88,
      88,    69,    88,    88,    88,    88,     8,    69,    69,    88,
      88,    88,    71,    31,    37,    71,    89,    69,    88,    69,
      69,    69,    69,    68,    91,     0,    12,    16,    42,    43,
      44,    45,    46,    47,    49,    53,    54,    57,    59,    61,
      63,    65,    70,    15,    73,    75,    71,    69,    88,    88,
      71,    71,    88,    71,    71,    71,    71,    88,    88,    88,
      71,    71,    71,    71,    69,    88,    89,    69,    69,    69,
      88,    89,    88,    82,    19,    69,    69,    69,    88,    50,
      69,    71,    19,    88,    19,    88,    71,    71,    69,    88,
      88,    71,    88,    88,    88,    88,    69,    88,    91,    91,
      88,    71,    71,    71,    71,    71,    71,    71,    69,    88,
      71,    69,    71,    78,    69,    77,    71,    31,    78,    71,
      78,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    69,    86,    71,    69,    71,    87,    87,    77,    69,
      79,    80,    71,    79,    80,    79,    71,    77,    69,    71,
      71,    77,    71
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    83,    84,    84,    85,    85,    85,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    85,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    85,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    85,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    85,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    85,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    85,    85,    85,    86,
      86,    86,    86,    86,    86,    87,    87,    87,    88,    88,
      88,    88,    88,    88,    89,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    89,    90,    90,
      90,    91,    91,    91,    91,    91
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     1,     1,     1,     1,     2,     3,     3,
       3,     4,     4,     3,     3,     3,     4,     3,     3,     4,
       4,     3,     4,     4,     3,     3,     2,     3,     3,     3,
       3,     4,     3,     4,     3,     4,     5,     3,     3,     4,
       3,     2,     2,     2,     4,     4,     3,     4,     3,     3,
       4,     5,     4,     3,     5,     4,     3,     4,     2,     5,
       4,     4,     4,     3,     4,     3,     6,     6,     6,     1,
       3,     2,     3,     4,     5,     1,     2,     3,     0,     1,
       1,     1,     1,     1,     0,     1,     1,     2,     2,     2,
       2,     1,     1,     1,     1,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     0,     1,
       1,     1,     3,     3,     2,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* prog: expr  */
#line 207 "filter/grammar.y"
                {   
		StartNode = (yyvsp[0].value); 
	}
#line 1676 "filter/grammar.c"
    break;

  case 4: /* term: ANY  */
#line 212 "filter/grammar.y"
            { /* this is an unconditionally true expression, as a filter applies in any case */
		data_t data = {.dataVal=1};
		(yyval.param).self = NewElement(EXheader, 0, 0, 0, CMP_EQ, FUNC_NONE, data);
	}
#line 1685 "filter/grammar.c"
    break;

  case 5: /* term: IPV4  */
#line 217 "filter/grammar.y"
               { 
		(yyval.param).self = NewElement(EXipv4FlowID, OFFsrc4Addr, 0, 0, CMP_EQ, FUNC_NONE, NULLPtr); 
	}
#line 1693 "filter/grammar.c"
    break;

  case 6: /* term: IPV6  */
#line 221 "filter/grammar.y"
               { 
		(yyval.param).self = NewElement(EXipv6FlowID, OFFsrc6Addr, 0, 0, CMP_EQ, FUNC_NONE, NULLPtr); 
	}
#line 1701 "filter/grammar.c"
    break;

  case 7: /* term: IDENT STRING  */
#line 225 "filter/grammar.y"
                       {
	  (yyval.param).self  = AddIdent((yyvsp[0].s)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1709 "filter/grammar.c"
    break;

  case 8: /* term: COUNT comp NUMBER  */
#line 229 "filter/grammar.y"
                            {
		(yyval.param).self = NewElement(EXlocal, OFFflowCount, SIZEflowCount, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULLPtr); 
	}
#line 1717 "filter/grammar.c"
    break;

  case 9: /* term: ENGINETYPE comp NUMBER  */
#line 233 "filter/grammar.y"
                                 {
	  (yyval.param).self  = AddEngineNum("type", (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
  }
#line 1725 "filter/grammar.c"
    break;

  case 10: /* term: ENGINEID comp NUMBER  */
#line 237 "filter/grammar.y"
                               {
	  (yyval.param).self  = AddEngineNum("id", (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1733 "filter/grammar.c"
    break;

  case 11: /* term: ENGINE STRING comp NUMBER  */
#line 241 "filter/grammar.y"
                                    {
		(yyval.param).self  = AddEngineNum((yyvsp[-2].s), (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1741 "filter/grammar.c"
    break;

  case 12: /* term: EXPORTER STRING comp NUMBER  */
#line 245 "filter/grammar.y"
                                {
 	  (yyval.param).self  = AddExporterNum((yyvsp[-2].s), (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1749 "filter/grammar.c"
    break;

  case 13: /* term: dqual PROTO NUMBER  */
#line 249 "filter/grammar.y"
                       { 
    (yyval.param).self = AddProto((yyvsp[-2].param).direction, NULL, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT; 
  }
#line 1757 "filter/grammar.c"
    break;

  case 14: /* term: dqual PROTO STRING  */
#line 253 "filter/grammar.y"
                       {
    (yyval.param).self = AddProto((yyvsp[-2].param).direction, (yyvsp[0].s), 0); if ( (yyval.param).self < 0 ) YYABORT;
  }
#line 1765 "filter/grammar.c"
    break;

  case 15: /* term: dqual PROTO ICMP  */
#line 257 "filter/grammar.y"
                     {
    (yyval.param).self = AddProto((yyvsp[-2].param).direction, "icmp", 0); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1773 "filter/grammar.c"
    break;

  case 16: /* term: dqual PORT comp NUMBER  */
#line 261 "filter/grammar.y"
                                 {
		(yyval.param).self = AddPortNumber((yyvsp[-3].param).direction, (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT; 
	}
#line 1781 "filter/grammar.c"
    break;

  case 17: /* term: ICMPTYPE comp NUMBER  */
#line 265 "filter/grammar.y"
                               {
		(yyval.param).self = AddICMP("type", (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT; 
	}
#line 1789 "filter/grammar.c"
    break;

  case 18: /* term: ICMPCODE comp NUMBER  */
#line 269 "filter/grammar.y"
                               {
		(yyval.param).self = AddICMP("code", (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT; 
	}
#line 1797 "filter/grammar.c"
    break;

  case 19: /* term: ICMP STRING comp NUMBER  */
#line 273 "filter/grammar.y"
                                  {
		(yyval.param).self  = AddICMP((yyvsp[-2].s), (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1805 "filter/grammar.c"
    break;

  case 20: /* term: dqual FLAGS comp NUMBER  */
#line 277 "filter/grammar.y"
                                  {
		(yyval.param).self = AddFlagsNumber((yyvsp[-3].param).direction, (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1813 "filter/grammar.c"
    break;

  case 21: /* term: dqual FLAGS STRING  */
#line 281 "filter/grammar.y"
                             {
		(yyval.param).self = AddFlagsString((yyvsp[-2].param).direction, (yyvsp[0].s)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1821 "filter/grammar.c"
    break;

  case 22: /* term: dqual TOS comp NUMBER  */
#line 285 "filter/grammar.y"
                                {
	  (yyval.param).self = AddTosNumber((yyvsp[-3].param).direction, (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1829 "filter/grammar.c"
    break;

  case 23: /* term: minmax IPTTL comp NUMBER  */
#line 289 "filter/grammar.y"
                                   {
	  (yyval.param).self = AddIPttl((yyvsp[-3].param).prefix, (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1837 "filter/grammar.c"
    break;

  case 24: /* term: minmax IPTTL STRING  */
#line 293 "filter/grammar.y"
                              {
	  (yyval.param).self = AddIPttlEqual((yyvsp[0].s)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1845 "filter/grammar.c"
    break;

  case 25: /* term: FWDSTAT comp NUMBER  */
#line 297 "filter/grammar.y"
                              {
	  (yyval.param).self = AddFwdStatNum((yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1853 "filter/grammar.c"
    break;

  case 26: /* term: FWDSTAT STRING  */
#line 301 "filter/grammar.y"
                         {
	  (yyval.param).self = AddFwdStatString((yyvsp[0].s)); if ( (yyval.param).self < 0 ) YYABORT;
  }
#line 1861 "filter/grammar.c"
    break;

  case 27: /* term: DURATION comp NUMBER  */
#line 305 "filter/grammar.y"
                               {
		(yyval.param).self = NewElement(EXgenericFlowID, 0, SIZEmsecLast, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_DURATION, NULLPtr); 
	}
#line 1869 "filter/grammar.c"
    break;

  case 28: /* term: PPS comp NUMBER  */
#line 309 "filter/grammar.y"
                          {
		(yyval.param).self = NewElement(EXgenericFlowID, 0, SIZEmsecLast, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_PPS, NULLPtr);
	}
#line 1877 "filter/grammar.c"
    break;

  case 29: /* term: BPS comp NUMBER  */
#line 313 "filter/grammar.y"
                          {
		(yyval.param).self = NewElement(EXgenericFlowID, 0, SIZEmsecLast, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_BPS, NULLPtr);
	}
#line 1885 "filter/grammar.c"
    break;

  case 30: /* term: BPP comp NUMBER  */
#line 317 "filter/grammar.y"
                          {
		(yyval.param).self = NewElement(EXgenericFlowID, 0, SIZEmsecLast, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_BPP, NULLPtr); 
	}
#line 1893 "filter/grammar.c"
    break;

  case 31: /* term: dqual PACKETS comp NUMBER  */
#line 321 "filter/grammar.y"
                                    {
		(yyval.param).self = AddPackets((yyvsp[-3].param).direction, (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1901 "filter/grammar.c"
    break;

  case 32: /* term: FLOWS comp NUMBER  */
#line 325 "filter/grammar.y"
                            {
		(yyval.param).self = NewElement(EXcntFlowID, OFFflows, SIZEflows, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULLPtr); 
	}
#line 1909 "filter/grammar.c"
    break;

  case 33: /* term: dqual BYTES comp NUMBER  */
#line 329 "filter/grammar.y"
                                  {
		(yyval.param).self = AddBytes((yyvsp[-3].param).direction, (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1917 "filter/grammar.c"
    break;

  case 34: /* term: dqual IP STRING  */
#line 333 "filter/grammar.y"
                          { 	
		(yyval.param).self = AddIP((yyvsp[-2].param).direction, (yyvsp[0].s)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1925 "filter/grammar.c"
    break;

  case 35: /* term: dqual NET STRING STRING  */
#line 337 "filter/grammar.y"
                                  {
		(yyval.param).self = AddNet((yyvsp[-3].param).direction, (yyvsp[-1].s), (yyvsp[0].s)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1933 "filter/grammar.c"
    break;

  case 36: /* term: dqual NET STRING '/' NUMBER  */
#line 341 "filter/grammar.y"
                                      {
		(yyval.param).self = AddNetPrefix((yyvsp[-4].param).direction, (yyvsp[-2].s), (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1941 "filter/grammar.c"
    break;

  case 37: /* term: dqual IF NUMBER  */
#line 345 "filter/grammar.y"
                          {
		(yyval.param).self = AddInterfaceNumber((yyvsp[-2].param).direction, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1949 "filter/grammar.c"
    break;

  case 38: /* term: dqual VLAN NUMBER  */
#line 349 "filter/grammar.y"
                            {
		(yyval.param).self = AddVlanNumber((yyvsp[-2].param).direction, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1957 "filter/grammar.c"
    break;

  case 39: /* term: dqual AS comp NUMBER  */
#line 353 "filter/grammar.y"
                               {
		(yyval.param).self = AddAsNumber((yyvsp[-3].param).direction, (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT; 
	}
#line 1965 "filter/grammar.c"
    break;

  case 40: /* term: dqual MASK NUMBER  */
#line 357 "filter/grammar.y"
                            {
		(yyval.param).self = AddMaskNumber((yyvsp[-2].param).direction, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1973 "filter/grammar.c"
    break;

  case 41: /* term: ETHERTYPE NUMBER  */
#line 361 "filter/grammar.y"
                           {
		(yyval.param).self = AddEthertype((yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1981 "filter/grammar.c"
    break;

  case 42: /* term: FLOWDIR NUMBER  */
#line 365 "filter/grammar.y"
                         {
		(yyval.param).self = AddFlowDir(DIR_UNSPEC, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 1989 "filter/grammar.c"
    break;

  case 43: /* term: FLOWDIR dqual  */
#line 369 "filter/grammar.y"
                        {
		(yyval.param).self = AddFlowDir((yyvsp[0].param).direction, -1); if ( (yyval.param).self < 0 ) YYABORT;
  }
#line 1997 "filter/grammar.c"
    break;

  case 44: /* term: MPLS STRING comp NUMBER  */
#line 373 "filter/grammar.y"
                                  {	
		(yyval.param).self = AddMPLS((yyvsp[-2].s), (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT; 
	}
#line 2005 "filter/grammar.c"
    break;

  case 45: /* term: MPLS ANY comp NUMBER  */
#line 377 "filter/grammar.y"
                               {	
		(yyval.param).self = AddMPLS("any", (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT; 
	}
#line 2013 "filter/grammar.c"
    break;

  case 46: /* term: dqual MAC STRING  */
#line 381 "filter/grammar.y"
                           {	
		(yyval.param).self = AddMAC((yyvsp[-2].param).direction, (yyvsp[0].s)); if ( (yyval.param).self < 0 ) YYABORT; 
	}
#line 2021 "filter/grammar.c"
    break;

  case 47: /* term: dqual LATENCY comp NUMBER  */
#line 385 "filter/grammar.y"
                                    {
		(yyval.param).self = AddLatency((yyvsp[-3].param).direction, (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT; 
	}
#line 2029 "filter/grammar.c"
    break;

  case 48: /* term: ASA STRING STRING  */
#line 389 "filter/grammar.y"
                            {
		(yyval.param).self = AddASAString((yyvsp[-1].s), (yyvsp[0].s)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2037 "filter/grammar.c"
    break;

  case 49: /* term: ASA STRING dqual  */
#line 393 "filter/grammar.y"
                           {
		switch ((yyvsp[0].param).direction) {
			case DIR_INGRESS:
				(yyval.param).self = AddASAString((yyvsp[-1].s), "ingress");
				break;
			case DIR_EGRESS:
				(yyval.param).self = AddASAString((yyvsp[-1].s), "egress");
				break;
			default:
				(yyval.param).self = -1;
				    yyerror("Unknown direction specifier");
		}
		if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2056 "filter/grammar.c"
    break;

  case 50: /* term: ASA STRING comp NUMBER  */
#line 408 "filter/grammar.y"
                                {
		(yyval.param).self = AddASA((yyvsp[-2].s), (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT; 
	}
#line 2064 "filter/grammar.c"
    break;

  case 51: /* term: dqual PORT IN NAT STRING  */
#line 412 "filter/grammar.y"
                                   {
		(yyval.param).self = AddASApblock((yyvsp[-4].param).direction, (yyvsp[0].s)); if ( (yyval.param).self < 0 ) YYABORT; 
	}
#line 2072 "filter/grammar.c"
    break;

  case 52: /* term: dqual ACL comp NUMBER  */
#line 416 "filter/grammar.y"
                                {
		(yyval.param).self = AddACL((yyvsp[-3].param).direction, (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT; 
	}
#line 2080 "filter/grammar.c"
    break;

  case 53: /* term: NAT STRING STRING  */
#line 420 "filter/grammar.y"
                            {
		(yyval.param).self = AddNATString((yyvsp[-1].s), (yyvsp[0].s)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2088 "filter/grammar.c"
    break;

  case 54: /* term: NAT STRING STRING comp NUMBER  */
#line 424 "filter/grammar.y"
                                        {
		(yyval.param).self = AddNatPortBlocks((yyvsp[-3].s), (yyvsp[-2].s), (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2096 "filter/grammar.c"
    break;

  case 55: /* term: NAT STRING comp NUMBER  */
#line 428 "filter/grammar.y"
                                 {
		(yyval.param).self = AddNAT((yyvsp[-2].s), (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT; 
	}
#line 2104 "filter/grammar.c"
    break;

  case 56: /* term: PAYLOAD STRING STRING  */
#line 432 "filter/grammar.y"
                                {
		(yyval.param).self = AddPayload((yyvsp[-1].s), (yyvsp[0].s), NULL); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2112 "filter/grammar.c"
    break;

  case 57: /* term: PAYLOAD STRING STRING STRING  */
#line 436 "filter/grammar.y"
                                       {
		(yyval.param).self = AddPayload((yyvsp[-2].s), (yyvsp[-1].s), (yyvsp[0].s)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2120 "filter/grammar.c"
    break;

  case 58: /* term: dqual GEOSTRING  */
#line 440 "filter/grammar.y"
                          {
		(yyval.param).self = AddGeo((yyvsp[-1].param).direction, (yyvsp[0].s)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2128 "filter/grammar.c"
    break;

  case 59: /* term: OBSERVATION STRING STRING comp NUMBER  */
#line 444 "filter/grammar.y"
                                                {
		(yyval.param).self = AddObservation((yyvsp[-3].s), (yyvsp[-2].s), (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2136 "filter/grammar.c"
    break;

  case 60: /* term: dqual VRF comp NUMBER  */
#line 448 "filter/grammar.y"
                                {
		(yyval.param).self = AddVRF((yyvsp[-3].param).direction, (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2144 "filter/grammar.c"
    break;

  case 61: /* term: STRING SEEN comp STRING  */
#line 452 "filter/grammar.y"
                                  {
		(yyval.param).self = AddTimeSting((yyvsp[-3].s), (yyvsp[-1].param).comp, (yyvsp[0].s)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2152 "filter/grammar.c"
    break;

  case 62: /* term: STRING SEEN comp NUMBER  */
#line 456 "filter/grammar.y"
                            {
		char s[32] = {0};
		int i = (yyvsp[0].value);
		snprintf(s, 31, "%d", i );
		(yyval.param).self = AddTimeSting((yyvsp[-3].s), (yyvsp[-1].param).comp, s); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2163 "filter/grammar.c"
    break;

  case 63: /* term: PF STRING STRING  */
#line 463 "filter/grammar.y"
                           {
		(yyval.param).self = AddPFString((yyvsp[-1].s), (yyvsp[0].s)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2171 "filter/grammar.c"
    break;

  case 64: /* term: PF STRING comp NUMBER  */
#line 467 "filter/grammar.y"
                                {
		(yyval.param).self = AddPFNumber((yyvsp[-2].s), (yyvsp[-1].param).comp, (yyvsp[0].value)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2179 "filter/grammar.c"
    break;

  case 65: /* term: PF STRING dqual  */
#line 471 "filter/grammar.y"
                          {
		switch ((yyvsp[0].param).direction) {
			case DIR_IN:
				(yyval.param).self = AddPFString((yyvsp[-1].s), "in");
				break;
			case DIR_OUT:
				(yyval.param).self = AddPFString((yyvsp[-1].s), "out");
				break;
			case DIR_UNSPEC_NAT:
				(yyval.param).self = AddPFString((yyvsp[-1].s), "nat");
				break;
			default:
				(yyval.param).self = -1;
				    yyerror("Unknown direction specifier");
		}
		if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2201 "filter/grammar.c"
    break;

  case 66: /* term: dqual IP IN '[' iplist ']'  */
#line 489 "filter/grammar.y"
                                     { 	
		(yyval.param).self = AddIPlist((yyvsp[-5].param).direction, (yyvsp[-1].list)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2209 "filter/grammar.c"
    break;

  case 67: /* term: dqual PORT IN '[' u64list ']'  */
#line 493 "filter/grammar.y"
                                        {
		(yyval.param).self = AddPortList((yyvsp[-5].param).direction, (yyvsp[-1].list)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2217 "filter/grammar.c"
    break;

  case 68: /* term: dqual AS IN '[' u64list ']'  */
#line 497 "filter/grammar.y"
                                      {
		(yyval.param).self = AddASList((yyvsp[-5].param).direction, (yyvsp[-1].list)); if ( (yyval.param).self < 0 ) YYABORT;
	}
#line 2225 "filter/grammar.c"
    break;

  case 69: /* iplist: STRING  */
#line 503 "filter/grammar.y"
                { 
		(yyval.list) = NewIplist((yyvsp[0].s), -1); if ( (yyval.list) == NULL ) YYABORT;
	}
#line 2233 "filter/grammar.c"
    break;

  case 70: /* iplist: STRING '/' NUMBER  */
#line 507 "filter/grammar.y"
                                { 
		(yyval.list) = NewIplist((yyvsp[-2].s), (yyvsp[0].value)); if ( (yyval.list) == NULL ) YYABORT;
	}
#line 2241 "filter/grammar.c"
    break;

  case 71: /* iplist: iplist STRING  */
#line 511 "filter/grammar.y"
                        { 
		if (InsertIPlist((yyvsp[-1].list), (yyvsp[0].s), -1) == 0 ) YYABORT;
	}
#line 2249 "filter/grammar.c"
    break;

  case 72: /* iplist: iplist ',' STRING  */
#line 515 "filter/grammar.y"
                            { 
		if (InsertIPlist((yyvsp[-2].list), (yyvsp[0].s), -1) == 0 ) YYABORT;
	}
#line 2257 "filter/grammar.c"
    break;

  case 73: /* iplist: iplist STRING '/' NUMBER  */
#line 519 "filter/grammar.y"
                                        { 
		if (InsertIPlist((yyvsp[-3].list), (yyvsp[-2].s), (yyvsp[0].value)) == 0 ) YYABORT;
	}
#line 2265 "filter/grammar.c"
    break;

  case 74: /* iplist: iplist ',' STRING '/' NUMBER  */
#line 523 "filter/grammar.y"
                                        { 
		if (InsertIPlist((yyvsp[-4].list), (yyvsp[-2].s), (yyvsp[0].value)) == 0 ) YYABORT;
	}
#line 2273 "filter/grammar.c"
    break;

  case 75: /* u64list: NUMBER  */
#line 528 "filter/grammar.y"
                { 
		(yyval.list) = NewU64list((yyvsp[0].value)); if ( (yyval.list) == NULL ) YYABORT;
	}
#line 2281 "filter/grammar.c"
    break;

  case 76: /* u64list: u64list NUMBER  */
#line 532 "filter/grammar.y"
                         { 
		if (InsertU64list((yyvsp[-1].list), (yyvsp[0].value)) == 0 ) YYABORT;
	}
#line 2289 "filter/grammar.c"
    break;

  case 77: /* u64list: u64list ',' NUMBER  */
#line 536 "filter/grammar.y"
                             { 
		if (InsertU64list((yyvsp[-2].list), (yyvsp[0].value)) == 0 ) YYABORT;
	}
#line 2297 "filter/grammar.c"
    break;

  case 78: /* comp: %empty  */
#line 542 "filter/grammar.y"
                                { (yyval.param).comp = CMP_EQ; }
#line 2303 "filter/grammar.c"
    break;

  case 79: /* comp: EQ  */
#line 543 "filter/grammar.y"
                                { (yyval.param).comp = CMP_EQ; }
#line 2309 "filter/grammar.c"
    break;

  case 80: /* comp: LT  */
#line 544 "filter/grammar.y"
                                { (yyval.param).comp = CMP_LT; }
#line 2315 "filter/grammar.c"
    break;

  case 81: /* comp: GT  */
#line 545 "filter/grammar.y"
                                { (yyval.param).comp = CMP_GT; }
#line 2321 "filter/grammar.c"
    break;

  case 82: /* comp: LE  */
#line 546 "filter/grammar.y"
                                { (yyval.param).comp = CMP_LE; }
#line 2327 "filter/grammar.c"
    break;

  case 83: /* comp: GE  */
#line 547 "filter/grammar.y"
                                { (yyval.param).comp = CMP_GE; }
#line 2333 "filter/grammar.c"
    break;

  case 84: /* dqual: %empty  */
#line 551 "filter/grammar.y"
             { (yyval.param).direction = DIR_UNSPEC;     }
#line 2339 "filter/grammar.c"
    break;

  case 85: /* dqual: SRC  */
#line 552 "filter/grammar.y"
                           { (yyval.param).direction = DIR_SRC;        }
#line 2345 "filter/grammar.c"
    break;

  case 86: /* dqual: DST  */
#line 553 "filter/grammar.y"
                           { (yyval.param).direction = DIR_DST;        }
#line 2351 "filter/grammar.c"
    break;

  case 87: /* dqual: SRC NAT  */
#line 554 "filter/grammar.y"
                         { (yyval.param).direction = DIR_SRC_NAT;	  }
#line 2357 "filter/grammar.c"
    break;

  case 88: /* dqual: DST NAT  */
#line 555 "filter/grammar.y"
                   { (yyval.param).direction = DIR_DST_NAT;	  }
#line 2363 "filter/grammar.c"
    break;

  case 89: /* dqual: SRC TUN  */
#line 556 "filter/grammar.y"
                         { (yyval.param).direction = DIR_SRC_TUN;    }
#line 2369 "filter/grammar.c"
    break;

  case 90: /* dqual: DST TUN  */
#line 557 "filter/grammar.y"
                   { (yyval.param).direction = DIR_DST_TUN;    }
#line 2375 "filter/grammar.c"
    break;

  case 91: /* dqual: NAT  */
#line 558 "filter/grammar.y"
                         { (yyval.param).direction = DIR_UNSPEC_NAT; }
#line 2381 "filter/grammar.c"
    break;

  case 92: /* dqual: TUN  */
#line 559 "filter/grammar.y"
                         { (yyval.param).direction = DIR_UNSPEC_TUN; }
#line 2387 "filter/grammar.c"
    break;

  case 93: /* dqual: IN  */
#line 560 "filter/grammar.y"
                           { (yyval.param).direction = DIR_IN;         }
#line 2393 "filter/grammar.c"
    break;

  case 94: /* dqual: OUT  */
#line 561 "filter/grammar.y"
                           { (yyval.param).direction = DIR_OUT;        }
#line 2399 "filter/grammar.c"
    break;

  case 95: /* dqual: IN SRC  */
#line 562 "filter/grammar.y"
                         { (yyval.param).direction = DIR_IN_SRC;     }
#line 2405 "filter/grammar.c"
    break;

  case 96: /* dqual: IN DST  */
#line 563 "filter/grammar.y"
                         { (yyval.param).direction = DIR_IN_DST;     }
#line 2411 "filter/grammar.c"
    break;

  case 97: /* dqual: OUT SRC  */
#line 564 "filter/grammar.y"
                         { (yyval.param).direction = DIR_OUT_SRC;	  }
#line 2417 "filter/grammar.c"
    break;

  case 98: /* dqual: OUT DST  */
#line 565 "filter/grammar.y"
                         { (yyval.param).direction = DIR_OUT_DST;    }
#line 2423 "filter/grammar.c"
    break;

  case 99: /* dqual: INGRESS  */
#line 566 "filter/grammar.y"
                         { (yyval.param).direction = DIR_INGRESS;    }
#line 2429 "filter/grammar.c"
    break;

  case 100: /* dqual: EGRESS  */
#line 567 "filter/grammar.y"
                         { (yyval.param).direction = DIR_EGRESS;     }
#line 2435 "filter/grammar.c"
    break;

  case 101: /* dqual: CLIENT  */
#line 568 "filter/grammar.y"
                         { (yyval.param).direction = DIR_CLIENT;     }
#line 2441 "filter/grammar.c"
    break;

  case 102: /* dqual: SERVER  */
#line 569 "filter/grammar.y"
                         { (yyval.param).direction = DIR_SERVER;     }
#line 2447 "filter/grammar.c"
    break;

  case 103: /* dqual: PREV  */
#line 570 "filter/grammar.y"
                         { (yyval.param).direction = DIR_PREV;       }
#line 2453 "filter/grammar.c"
    break;

  case 104: /* dqual: NEXT  */
#line 571 "filter/grammar.y"
                         { (yyval.param).direction = DIR_NEXT;       }
#line 2459 "filter/grammar.c"
    break;

  case 105: /* dqual: BGP NEXT  */
#line 572 "filter/grammar.y"
                   { (yyval.param).direction = BGP_NEXT;	      }
#line 2465 "filter/grammar.c"
    break;

  case 106: /* dqual: ROUTER  */
#line 573 "filter/grammar.y"
                         { (yyval.param).direction = SRC_ROUTER;     }
#line 2471 "filter/grammar.c"
    break;

  case 107: /* dqual: EXPORTER  */
#line 574 "filter/grammar.y"
                   { (yyval.param).direction = SRC_ROUTER;     }
#line 2477 "filter/grammar.c"
    break;

  case 108: /* minmax: %empty  */
#line 577 "filter/grammar.y"
             { (yyval.param).prefix = PRE_UNKNOWN; }
#line 2483 "filter/grammar.c"
    break;

  case 109: /* minmax: MIN  */
#line 578 "filter/grammar.y"
                           { (yyval.param).prefix = PRE_MIN;     }
#line 2489 "filter/grammar.c"
    break;

  case 110: /* minmax: MAX  */
#line 579 "filter/grammar.y"
                           { (yyval.param).prefix = PRE_MAX;     }
#line 2495 "filter/grammar.c"
    break;

  case 111: /* expr: term  */
#line 582 "filter/grammar.y"
             { (yyval.value) = (yyvsp[0].param).self; }
#line 2501 "filter/grammar.c"
    break;

  case 112: /* expr: expr OR expr  */
#line 583 "filter/grammar.y"
                        { (yyval.value) = Connect_OR((yyvsp[-2].value), (yyvsp[0].value));   }
#line 2507 "filter/grammar.c"
    break;

  case 113: /* expr: expr AND expr  */
#line 584 "filter/grammar.y"
                        { (yyval.value) = Connect_AND((yyvsp[-2].value), (yyvsp[0].value));  }
#line 2513 "filter/grammar.c"
    break;

  case 114: /* expr: NOT expr  */
#line 585 "filter/grammar.y"
                                        { (yyval.value) = Invert((yyvsp[0].value)); }
#line 2519 "filter/grammar.c"
    break;

  case 115: /* expr: '(' expr ')'  */
#line 586 "filter/grammar.y"
                        { (yyval.value) = (yyvsp[-1].value); }
#line 2525 "filter/grammar.c"
    break;


#line 2529 "filter/grammar.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 589 "filter/grammar.y"


#define EBUFFSIZE 512
static char ebuf[EBUFFSIZE];

static void yyerror(char *msg) {
	if ( FilterFilename ) {
		printf("File '%s' line %d: %s at '%s'\n", FilterFilename, lineno, msg, yytext);
	} else {
		printf("Line %d: %s at '%s'\n", lineno, msg, yytext);
	}
} /* End of     */

#define yyprintf(...) do { \
    snprintf(ebuf, EBUFFSIZE, __VA_ARGS__); \
    yyerror(ebuf); \
} while (0)

static uint32_t NewIPElement(ipStack_t *ipStack, int direction, int comp, data_t *data) {

	int block = -1;

	if ( ipStack->af == PF_INET ) {
		// handle IPv4 addr element
		switch ( direction ) {
			case DIR_SRC:
				block = NewElement(EXipv4FlowID, OFFsrc4Addr, SIZEsrc4Addr, ipStack->ipaddr[1], comp, FUNC_NONE, data[0]); 
				break;
			case DIR_DST:
				block = NewElement(EXipv4FlowID, OFFdst4Addr, SIZEdst4Addr, ipStack->ipaddr[1], comp, FUNC_NONE, data[0]); 
				break;
			case DIR_SRC_NAT:
				block = NewElement(EXnatXlateIPv4ID, OFFxlateSrc4Addr, SIZExlateSrc4Addr, ipStack->ipaddr[1], comp, FUNC_NONE, data[0]); 
				break;
			case DIR_DST_NAT:
				block = NewElement(EXnatXlateIPv4ID, OFFxlateDst4Addr, SIZExlateDst4Addr, ipStack->ipaddr[1], comp, FUNC_NONE, data[0]); 
				break;
			case DIR_SRC_TUN:
				block = NewElement(EXtunIPv4ID, OFFtunSrc4Addr, SIZEtunSrc4Addr, ipStack->ipaddr[1], comp, FUNC_NONE, data[0]); 
				break;
			case DIR_DST_TUN:
				block = NewElement(EXtunIPv4ID, OFFtunDst4Addr, SIZEtunDst4Addr, ipStack->ipaddr[1], comp, FUNC_NONE, data[0]); 
				break;
			case DIR_NEXT:
				block = NewElement(EXipNextHopV4ID, OFFNextHopV4IP, SIZENextHopV4IP, ipStack->ipaddr[1], comp, FUNC_NONE, data[0]); 
				break;
			case BGP_NEXT:
				block = NewElement(EXbgpNextHopV4ID, OFFbgp4NextIP, SIZEbgp4NextIP, ipStack->ipaddr[1], comp, FUNC_NONE, data[0]); 
				break;
			case SRC_ROUTER:
				block = NewElement(EXipReceivedV4ID, OFFReceived4IP, SIZEReceived4IP, ipStack->ipaddr[1], comp, FUNC_NONE, data[0]); 
				break;
		} // End of switch

	} else {
		// handle IPv6 addr element
		int v6_1, v6_2 = 0;
		switch ( direction ) {
			case DIR_SRC:
				v6_1 = NewElement(EXipv6FlowID, OFFsrc6Addr, sizeof(uint64_t), ipStack->ipaddr[0], comp, FUNC_NONE, data[0]);
				v6_2 = NewElement(EXipv6FlowID, OFFsrc6Addr + sizeof(uint64_t), sizeof(uint64_t), ipStack->ipaddr[1], comp, FUNC_NONE, data[1]);
				break;
			case DIR_DST:
				v6_1 = NewElement(EXipv6FlowID, OFFdst6Addr, sizeof(uint64_t), ipStack->ipaddr[0], comp, FUNC_NONE, data[0]);
				v6_2 = NewElement(EXipv6FlowID, OFFdst6Addr + sizeof(uint64_t), sizeof(uint64_t), ipStack->ipaddr[1], comp, FUNC_NONE, data[1]);
				break;
			case DIR_SRC_NAT:
				v6_1 = NewElement(EXnatXlateIPv6ID, OFFxlateSrc6Addr, sizeof(uint64_t), ipStack->ipaddr[0], comp, FUNC_NONE, data[0]);
				v6_2 = NewElement(EXnatXlateIPv6ID, OFFxlateSrc6Addr + sizeof(uint64_t), sizeof(uint64_t), ipStack->ipaddr[1], comp, FUNC_NONE, data[1]);
				break;
			case DIR_DST_NAT:
				v6_1 = NewElement(EXnatXlateIPv6ID, OFFxlateDst6Addr, sizeof(uint64_t), ipStack->ipaddr[0], comp, FUNC_NONE, data[0]);
				v6_2 = NewElement(EXnatXlateIPv6ID, OFFxlateDst6Addr + sizeof(uint64_t), sizeof(uint64_t), ipStack->ipaddr[1], comp, FUNC_NONE, data[1]);
				break;
			case DIR_SRC_TUN:
				v6_1 = NewElement(EXtunIPv6ID, OFFtunSrc6Addr, sizeof(uint64_t), ipStack->ipaddr[0], comp, FUNC_NONE, data[0]);
				v6_2 = NewElement(EXtunIPv6ID, OFFtunSrc6Addr + sizeof(uint64_t), sizeof(uint64_t), ipStack->ipaddr[1], comp, FUNC_NONE, data[1]);
				break;
			case DIR_DST_TUN:
				v6_1 = NewElement(EXtunIPv6ID, OFFtunDst6Addr, sizeof(uint64_t), ipStack->ipaddr[0], comp, FUNC_NONE, data[0]);
				v6_2 = NewElement(EXtunIPv6ID, OFFtunDst6Addr + sizeof(uint64_t), sizeof(uint64_t), ipStack->ipaddr[1], comp, FUNC_NONE, data[1]);
				break;
			case DIR_NEXT:
				v6_1 = NewElement(EXipNextHopV6ID, OFFNextHopV6IP, sizeof(uint64_t), ipStack->ipaddr[0], comp, FUNC_NONE, data[0]);
				v6_2 = NewElement(EXipNextHopV6ID, OFFNextHopV6IP + sizeof(uint64_t), sizeof(uint64_t), ipStack->ipaddr[1], comp, FUNC_NONE, data[1]);
				break;
			case BGP_NEXT:
				v6_1 = NewElement(EXbgpNextHopV6ID, OFFbgp6NextIP, sizeof(uint64_t), ipStack->ipaddr[0], comp, FUNC_NONE, data[0]);
				v6_2 = NewElement(EXbgpNextHopV6ID, OFFbgp6NextIP + sizeof(uint64_t), sizeof(uint64_t), ipStack->ipaddr[1], comp, FUNC_NONE, data[1]);
				break;
			case SRC_ROUTER:
				v6_1 = NewElement(EXipReceivedV6ID, OFFReceived6IP, sizeof(uint64_t), ipStack->ipaddr[0], comp, FUNC_NONE, data[0]);
				v6_2 = NewElement(EXipReceivedV6ID, OFFReceived6IP + sizeof(uint64_t), sizeof(uint64_t), ipStack->ipaddr[1], comp, FUNC_NONE, data[1]);
				break;
		} // End of switch

		// IPv6
		if ( v6_1 && v6_2 )
			block = Connect_AND(v6_1, v6_2);

	}

	return block;
} // NewIPElement

static uint32_t ChainHosts(ipStack_t *ipStack, int numIP, int direction) {

	data_t data[2] = { NULLPtr, NULLPtr };

	uint32_t final = 0;
	int i = 0;
	do {
		// chain multiple IPs
		int block = NewIPElement(&ipStack[i], direction, CMP_EQ, data);
		final = final == 0 ? block : Connect_OR(final, block);

	} while (++i < numIP);
	
	return final;
} // End of ChainHosts

static int AddIdent(char *ident) {
	char *c;

	// ident[a-zA-Z0-9_\-]+ { 
	size_t len = strlen(ident);
	if ( len == 0 || len > 255 ) {
		yyprintf("Invalid ident string: %s", ident);
		return -1;
	}
	
	c = &ident[0];
	while ( *c ) {
		if ( *c != '_' && *c != '-' && !isalnum(*c) ) {
			yyprintf("Invalid char in ident string: %s: %c", ident, *c);
			return 0;
		}
		c++;
	}
	
	data_t data = {.dataPtr = strdup(ident)};
	return NewElement(EXheader, 0, 0, 0, CMP_IDENT, FUNC_NONE, data); 

} // End of AddIdent

static int AddProto(direction_t direction, char *protoStr, uint64_t protoNum) {

	if ( protoNum > 255 ) {
		yyprintf("Protocol %" PRIu64 " out of range", protoNum);
		return -1;
	}

	if ( protoStr != NULL ) {
		protoNum = ProtoNum(protoStr);
  	if ( protoNum == -1 ) {
	  	yyprintf("Unknown protocol: %s", protoStr);
			Protoinfo(protoStr);
			return -1;
  	}
	}

	if ( direction == DIR_UNSPEC ) {
		return NewElement(EXgenericFlowID, OFFproto, SIZEproto, protoNum, CMP_EQ, FUNC_NONE, NULLPtr); 
	} else if ( direction == DIR_UNSPEC_TUN ) {
		return Connect_OR(
			NewElement(EXtunIPv4ID, OFFtunProtoV4, SIZEtunProtoV4, protoNum, CMP_EQ, FUNC_NONE, NULLPtr),
			NewElement(EXtunIPv6ID, OFFtunProtoV6, SIZEtunProtoV6, protoNum, CMP_EQ, FUNC_NONE, NULLPtr)
		);
	} else {
	  	yyprintf("Unknown protocol specifier");
			return -1;
	}
} // End of AddProtoString

static int AddEngineNum(char *type, uint16_t comp, uint64_t num) {
	if ( num > 255 ) {
		yyprintf("Engine argument %" PRIu64 " of range 0..255", num);
		return -1;
  }

	int ret = -1;
	if ( strcasecmp(type, "type") == 0 ) {
		ret = NewElement(EXheader, OFFengineType, SIZEengineType, num, comp, FUNC_NONE, NULLPtr);
	} else if ( strcasecmp(type, "id") == 0 ) {
		ret = NewElement(EXheader, OFFengineID, SIZEengineID, num, comp, FUNC_NONE, NULLPtr);
	}

	return ret;
} // End of AddEngineNum

static int AddExporterNum(char *type, uint16_t comp, uint64_t num) {
	if ( num > 65535 ) {
	  yyprintf("Exporter argument %" PRIu64 " of range 0..65535", num);
		return -1;
	}

	int ret = -1;
  if ((strcasecmp(type, "id") == 0 ) || (strcasecmp(type, "sysid") == 0)) {
		ret = NewElement(EXheader, OFFexporterID, SIZEexporterID, num, comp, FUNC_NONE, NULLPtr);
	} else {
	  yyprintf("Unknown exporter argument: %s", type);
	}

	return ret;
} // End of AddExporterNum

static int AddPortNumber(direction_t direction, uint16_t comp, uint64_t port) {
	if ( port > 65535 ) {
		  yyprintf("Port number: %" PRIu64 " out of range", port);
			return -1;
	}

	int ret = -1;
  switch ( direction ) {
	  case DIR_SRC:
		  ret = NewElement(EXgenericFlowID, OFFsrcPort, SIZEsrcPort, port, comp, FUNC_NONE, NULLPtr);
		  break;
	  case DIR_DST:
		  ret = NewElement(EXgenericFlowID, OFFdstPort, SIZEdstPort, port, comp, FUNC_NONE, NULLPtr);
		  break;
	  case DIR_SRC_NAT:
		  ret = NewElement(EXnatXlatePortID, OFFxlateSrcPort, SIZExlateSrcPort, port, comp, FUNC_NONE, NULLPtr);
		  break;
	  case DIR_DST_NAT:
		  ret = NewElement(EXnatXlatePortID, OFFxlateDstPort, SIZExlateDstPort, port, comp, FUNC_NONE, NULLPtr);
		  break;
	  case DIR_UNSPEC:
		  ret = Connect_OR(
			  NewElement(EXgenericFlowID, OFFsrcPort, SIZEsrcPort, port, comp, FUNC_NONE, NULLPtr),
			  NewElement(EXgenericFlowID, OFFdstPort, SIZEdstPort, port, comp, FUNC_NONE, NULLPtr)
		  );
		  break;
	  case DIR_UNSPEC_NAT:
		  ret = Connect_OR(
		  	NewElement(EXnatXlatePortID, OFFxlateSrcPort, SIZExlateSrcPort, port, comp, FUNC_NONE, NULLPtr),
		  	NewElement(EXnatXlatePortID, OFFxlateDstPort, SIZExlateDstPort, port, comp, FUNC_NONE, NULLPtr)
		  );
		  break;
	  default:
		  yyprintf("Unknown direction");
  } // End switch

	return ret;
} // End of AddPortNumber

static int AddICMP(char *type, uint16_t comp, uint64_t number) {
	if ( number > 255 ) {
		  yyprintf("ICMP argument %" PRIu64 " of range 0..255", number);
			return -1;
  }

	int ret = -1;
	// imply ICMP-TYPE with a proto ICMP block
	int protoICMP = Connect_OR (
			  NewElement(EXgenericFlowID, OFFproto, SIZEproto, IPPROTO_ICMP, CMP_EQ, FUNC_NONE, NULLPtr), 
			  NewElement(EXgenericFlowID, OFFproto, SIZEproto, IPPROTO_ICMPV6, CMP_EQ, FUNC_NONE, NULLPtr)
		  );
	if ( strcasecmp(type, "type") == 0 ) {
		ret = Connect_AND(
			protoICMP,
		  NewElement(EXgenericFlowID, OFFicmpType, SIZEicmpType, number, comp, FUNC_NONE, NULLPtr)
	  );
	} else if ( strcasecmp(type, "code") == 0 ) {
		ret = Connect_AND(
			protoICMP,
			NewElement(EXgenericFlowID, OFFicmpCode, SIZEicmpCode, number, comp, FUNC_NONE, NULLPtr)
	  );
	} 

	return ret;
} // End of AddICMP

static int AddFlagsNumber(direction_t direction, uint16_t comp, uint64_t flags) {
	if ( flags > 255 ) {
		  yyprintf("flags number %" PRIu64 " > 255", flags);
			return -1;
	}

	// direction ignored

	return Connect_AND(
	  // imply flags with proto TCP
	  NewElement(EXgenericFlowID, OFFproto, SIZEproto, IPPROTO_TCP, CMP_EQ, FUNC_NONE, NULLPtr), 
	  NewElement(EXgenericFlowID, OFFtcpFlags, SIZEtcpFlags, flags, comp, FUNC_NONE, NULLPtr)
  );
} // End of AddFlagsNumber

static int AddFlagsString(direction_t direction, char *flags) {
	size_t len = strlen(flags);
  if ( len > 10 ) {
	  yyprintf("Flags string error");
		return -1;
  }

	int strict = 0;
	if ( flags[0] == '=') {
	  strict = 1;
	  len--;
  }

  int cnt     = 0;
  uint64_t fl = 0;
  if ( strchr(flags, 'F') ) { fl |=  1; cnt++; }
  if ( strchr(flags, 'S') ) { fl |=  2; cnt++; }
  if ( strchr(flags, 'R') ) { fl |=  4; cnt++; }
  if ( strchr(flags, 'P') ) { fl |=  8; cnt++; }
  if ( strchr(flags, 'A') ) { fl |=  16; cnt++; }
  if ( strchr(flags, 'U') ) { fl |=  32; cnt++; }
  if ( strchr(flags, 'E') ) { fl |=  64; cnt++; }
  if ( strchr(flags, 'C') ) { fl |= 128; cnt++; }
  if ( strchr(flags, 'X') ) { fl =  63; cnt++; }

  if ( cnt != len ) {
	  yyprintf("Unknown flags");
		return -1;
  }

  if (strict) {
		return AddFlagsNumber(direction, CMP_EQ, fl);
  } else {
		return AddFlagsNumber(direction, CMP_FLAGS, fl);
  }

	// unreached
} // End of AddFlagsString

static int AddTosNumber(direction_t direction, uint16_t comp, uint64_t tos) {
	if ( tos > 255 ) {
		yyprintf("Tos number %" PRIu64 " out of range", tos);
		return -1;
  }

	int ret = -1;
  switch (direction) {
	  case DIR_UNSPEC:
	  case DIR_SRC: 
		  ret = NewElement(EXgenericFlowID, OFFsrcTos, SIZEsrcTos, tos, comp, FUNC_NONE, NULLPtr);
		  break;
	  case DIR_DST: 
		  ret = NewElement(EXflowMiscID, OFFdstTos, SIZEdstTos, tos, comp, FUNC_NONE, NULLPtr);
		  break;
	  default:
		  yyprintf("syntax error");
  } // End of switch

	return ret;
} // End of AddTosNumber

static int AddIPttl(prefix_t prefix, uint16_t comp, uint64_t ttl) {
	if ( ttl > 255 ) {
		yyprintf("TTL number out of range");
		return -1;
  }

	int ret = 0;
	switch (prefix) {
		case PRE_UNKNOWN:
			ret = Connect_OR(
				NewElement(EXipInfoID, OFFminTTL, SIZEminTTL, ttl, comp, FUNC_NONE, NULLPtr),
				NewElement(EXipInfoID, OFFmaxTTL, SIZEmaxTTL, ttl, comp, FUNC_NONE, NULLPtr));
			break;
		case PRE_MIN:
			ret = NewElement(EXipInfoID, OFFminTTL, SIZEminTTL, ttl, comp, FUNC_NONE, NULLPtr);
			break;
		case PRE_MAX:
			ret = NewElement(EXipInfoID, OFFmaxTTL, SIZEmaxTTL, ttl, comp, FUNC_NONE, NULLPtr);
			break;
	}
	return ret;

} // End of AddIPttl

static int AddIPttlEqual(char *arg) {
	if (strcasecmp(arg, "equal") != 0 ) {
		yyprintf("Unexpected argument: %s", arg);
		return -1;
	}
	
	return NewElement(EXipInfoID, OFFminTTL, SIZEminTTL, 1, CMP_EQ, FUNC_TTL_EQUAL, NULLPtr);
} // End of AddIPttlEqual

static int AddPackets(direction_t direction, uint16_t comp, uint64_t packets) {

	int ret = -1;
	switch ( direction ) {
		case DIR_UNSPEC:
	  case DIR_IN: 
		  ret = NewElement(EXgenericFlowID, OFFinPackets, SIZEinPackets, packets, comp, FUNC_NONE, NULLPtr); 
		  break;
	  case DIR_OUT: 
		  ret = NewElement(EXcntFlowID, OFFoutPackets, SIZEoutPackets, packets, comp, FUNC_NONE, NULLPtr); 
		break;
	  default:
		  yyprintf("Invalid direction for packets");
	} // End of switch
	return ret;
} // End of AddPackets

static int AddBytes(direction_t direction, uint16_t comp, uint64_t bytes) {
	int ret = -1;
	switch ( direction ) {
	  case DIR_UNSPEC:
	  case DIR_IN: 
		  ret = NewElement(EXgenericFlowID, OFFinBytes, SIZEinBytes, bytes, comp, FUNC_NONE, NULLPtr); 
		  break;
	  case DIR_OUT: 
		  ret = NewElement(EXcntFlowID, OFFoutBytes, SIZEoutBytes, bytes, comp, FUNC_NONE, NULLPtr); 
		  break;
	  default:
		  yyprintf("Invalid direction for bytes");
	 } // End of switch
	 return ret;
} // End of AddBytes

static int AddFwdStatNum(uint16_t comp, uint64_t num) {
	if ( num > 255 ) {
	  yyprintf("Forwarding status: %" PRIu64 " our of range", num);
		return -1;
	}

	return NewElement(EXgenericFlowID, OFFfwdStatus, SIZEfwdStatus, num, comp, FUNC_NONE, NULLPtr);
} // End of AddFwdStatNum

static int AddFwdStatString(char *string) {
	int	fwdStatus = fwdStatusNum(string);
	if ( fwdStatus < 0 ) {
	  fwdStatusInfo();
	  yyprintf("Unkown forwarding status: %s", string);
		return -1;
	}

	return NewElement(EXgenericFlowID, OFFfwdStatus, SIZEfwdStatus, fwdStatus, CMP_EQ, FUNC_NONE, NULLPtr);
} // End of AddFwdStatString

static int AddMPLS(char *type, uint16_t comp, uint64_t value) {
	if ( strncasecmp(type, "label", 5) == 0 ) {
		char *s = type + 5;
		if ( *s == '\0' ) {
			yyprintf("Missing mpls stack number for label");
			return -1;
		}
		int lnum = (int)strtol(s, (char **)NULL, 10);
		data_t labelIndex = { .dataVal = lnum};
		return NewElement(EXmplsLabelID, 0, 0, value, comp, FUNC_MPLS_LABEL, labelIndex);
	} else if ( strcasecmp(type, "any") == 0 ) {
		data_t labelValue = { .dataVal = value};
		return NewElement(EXmplsLabelID, 0, 0, value, comp, FUNC_MPLS_ANY, labelValue);
	} else if ( strcasecmp(type, "eos") == 0 ) {
		// match End of Stack label 
		return NewElement(EXmplsLabelID, 0, 0, value, comp, FUNC_MPLS_EOS, NULLPtr);
	} else if ( strncasecmp(type, "exp", 3) == 0 ) {
		char *s = type + 3;
		if ( *s == '\0' ) {
			yyprintf("Missing mpls stack number for exp value");
			return -1;
		}
		int lnum = (int)strtol(s, (char **)NULL, 10);
		data_t data = {.dataVal = lnum};
		return NewElement(EXmplsLabelID, 0, 0, value, comp, FUNC_MPLS_EXP, data);
	} else {
			yyprintf("Unknown mpls argument: %s", type);
			return -1;
	}

	// unreached
	return -1;
} // End of AddMPLS

static int AddEthertype(uint64_t etherType) {
	return NewElement(EXlayer2ID, OFFetherType, SIZEetherType, etherType, CMP_EQ, FUNC_NONE, NULLPtr);
} // End of AddMAC

static int AddMAC(direction_t direction, char *macString) {

	uint64_t macVal = Str2Mac(macString);
	if ( macVal == 0 ) return -1;

	switch (direction) {
		case DIR_IN_SRC:
			return NewElement(EXmacAddrID, OFFinSrcMac, SIZEinSrcMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr);
			break;
		case DIR_IN_DST:
			return NewElement(EXmacAddrID, OFFinDstMac, SIZEinDstMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr);
			break;
		case DIR_OUT_SRC:
			return NewElement(EXmacAddrID, OFFoutSrcMac, SIZEoutSrcMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr);
			break;
		case DIR_OUT_DST:
			return NewElement(EXmacAddrID, OFFoutDstMac, SIZEoutDstMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr);
			break;
		case DIR_SRC:
			return Connect_OR (
				NewElement(EXmacAddrID, OFFinSrcMac, SIZEinSrcMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr),
				NewElement(EXmacAddrID, OFFoutSrcMac, SIZEoutSrcMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr)
			);
			break;
		case DIR_DST:
			return Connect_OR (
				NewElement(EXmacAddrID, OFFinDstMac, SIZEinDstMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr),
				NewElement(EXmacAddrID, OFFoutDstMac, SIZEoutDstMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr)
			);
			break;
		case DIR_IN:
			return Connect_OR (
				NewElement(EXmacAddrID, OFFinSrcMac, SIZEinSrcMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr),
				NewElement(EXmacAddrID, OFFinDstMac, SIZEinDstMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr)
			);
			break;
		case DIR_OUT:
			return Connect_OR (
				NewElement(EXmacAddrID, OFFoutSrcMac, SIZEoutSrcMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr),
				NewElement(EXmacAddrID, OFFoutDstMac, SIZEoutDstMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr)
			);
			break;
		case DIR_UNSPEC: {
				int in = Connect_OR (
					NewElement(EXmacAddrID, OFFinSrcMac, SIZEinSrcMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr),
					NewElement(EXmacAddrID, OFFinDstMac, SIZEinDstMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr)
				);
				int out = Connect_OR (
					NewElement(EXmacAddrID, OFFoutSrcMac, SIZEoutSrcMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr),
					NewElement(EXmacAddrID, OFFoutDstMac, SIZEoutDstMac, macVal, CMP_EQ, FUNC_NONE, NULLPtr)
				);
				return Connect_OR(in, out);
			} break;
		default:
			yyprintf("Unknown mac argument");
			return -1;
	}

	// unreached
	return -1;
} // End of AddMAC

static int AddLatency(direction_t direction, uint16_t comp, uint64_t number) {

	int ret = -1;
  switch (direction) {
		case DIR_CLIENT:
			ret =  NewElement(EXlatencyID, OFFusecClientNwDelay, SIZEusecClientNwDelay, number, comp, FUNC_NONE, NULLPtr);
		  break;
		case DIR_SERVER:
			ret =  NewElement(EXlatencyID, OFFusecServerNwDelay, SIZEusecServerNwDelay, number, comp, FUNC_NONE, NULLPtr);
		  break;
		// case XXX	ret =  NewElement(EXlatencyID, OFFusecApplLatency, SIZEusecApplLatency, number, comp, FUNC_NONE, NULLPtr);
		default:
			yyprintf("Unknown latency argument");
  }

	return ret;
} // End of AddLatency

static int AddASAString(char *event, char *asaStr) {

	if (strcasecmp(event, "event") == 0) {
		int eventNum = fwEventID(asaStr);
		if ( eventNum < 0 ) {
			yyprintf("Invalid ASA event type: %s", asaStr);
			return -1;
		}
		return NewElement(EXnselCommonID, OFFfwEvent, SIZEfwEvent, eventNum, CMP_EQ, FUNC_NONE, NULLPtr);
	} else if (strcasecmp(event, "denied") == 0) {
		int eventNum = fwXEventID(asaStr);
		if ( eventNum < 0 ) {
			yyprintf("Invalid ASA Xevent type: %s", asaStr);
			return -1;
		}
		return NewElement(EXnselCommonID, OFFfwXevent, SIZEfwXevent, eventNum, CMP_EQ, FUNC_NONE, NULLPtr);
	} else if (strcasecmp(event, "user") == 0) {
		if ( strlen(asaStr) > 65 ) {
			yyprintf("Length of ASA user name > 65 chars");
			return -1;
		}
		data_t data = {.dataPtr = strdup(asaStr)};
		return NewElement(EXnselUserID, OFFusername, 0, 0, CMP_STRING, FUNC_NONE, data);
	}

	yyprintf("Invalid ASA type: %s", event);
	return -1;

} // End of AddASAString

static int AddASA(char *event, uint16_t comp, uint64_t number) {

	if ( strcasecmp(event, "event") == 0 ) {
		if ( number > 5 ) {
			yyprintf("Invalid event number %" PRIu64 ". Expected 0..5", number);
			return -1;
		}
		return NewElement(EXnselCommonID, OFFfwEvent, SIZEfwEvent, number, comp, FUNC_NONE, NULLPtr);
	} else if ( strcasecmp(event, "xevent") == 0 ) {
		return NewElement(EXnselCommonID, OFFfwXevent, SIZEfwXevent, number, comp, FUNC_NONE, NULLPtr);
	}

	yyprintf("Invalid ASA type: %s", event);
	return -1;

} // End of AddASA

static int AddACL(direction_t direction, uint16_t comp, uint64_t number) {

	uint32_t offset = 0;
	switch (direction) {
		case DIR_INGRESS:
			offset = OFFingressAcl;
			break;
		case DIR_EGRESS:
			offset = OFFegressAcl;
			break;
		default:
			yyprintf("Invalid ACL direction");
			return -1;
	}
	
	uint32_t acl[3];
	acl[0] = NewElement(EXnselAclID, offset, sizeof(uint32_t), number, comp, FUNC_NONE, NULLPtr);
	acl[1] = NewElement(EXnselAclID, offset + sizeof(uint32_t), sizeof(uint32_t), number, comp, FUNC_NONE, NULLPtr);
	acl[2] = NewElement(EXnselAclID, offset + 2*sizeof(uint32_t), sizeof(uint32_t), number, comp, FUNC_NONE, NULLPtr);
	return Connect_OR (
		Connect_OR(acl[0], acl[1]), acl[2]
	);
	return -1;

} // End of AddASA

static int AddASApblock(direction_t direction, char *arg) {

	if (strcasecmp(arg, "pblock") != 0) {
			yyprintf("Invalid port block: %s", arg);
			return -1;
	}

	int ret = -1;
	switch (direction) {
		case DIR_SRC:
		  ret = NewElement(EXgenericFlowID, OFFsrcPort, SIZEsrcPort, 1, CMP_EQ, FUNC_PBLOCK, NULLPtr);
		  break;
	  case DIR_DST:
		  ret = NewElement(EXgenericFlowID, OFFdstPort, SIZEdstPort, 1, CMP_EQ, FUNC_PBLOCK, NULLPtr);
		  break;
	  case DIR_UNSPEC:
		  ret = Connect_OR(
			  NewElement(EXgenericFlowID, OFFsrcPort, SIZEsrcPort, 1, CMP_EQ, FUNC_PBLOCK, NULLPtr),
			  NewElement(EXgenericFlowID, OFFdstPort, SIZEdstPort, 1, CMP_EQ, FUNC_PBLOCK, NULLPtr)
		  );
		  break;
		default:
			yyprintf("Invalid port direction");
	}

	return ret;
} // End of AddASApblock

static int AddNATString(char *event, char *natStr) {

	if (strcasecmp(event, "event") == 0) {
		int eventNum = natEventNum(natStr);
		if ( eventNum < 0 ) {
			yyprintf("Invalid NAT event type: %s", natStr);
			natEventInfo();
			return -1;
		}
		return NewElement(EXnatCommonID, OFFnatEvent, SIZEnatEvent, eventNum, CMP_EQ, FUNC_NONE, NULLPtr);
	} 

	yyprintf("Invalid NAT type: %s", event);

	return -1;

} // End of AddNATString

static int AddNAT(char *event, uint16_t comp, uint64_t number) {

	if (strcasecmp(event, "event") == 0) {
		if ( number > MAX_NAT_EVENTS ) {
			yyprintf("NAT event: %" PRIu64 " out of range", number);
			return -1;
		}
		return NewElement(EXnatCommonID, OFFnatEvent, SIZEnatEvent, number, comp, FUNC_NONE, NULLPtr);
	} 

	return -1;
} // End of AddNAT

static int AddNatPortBlocks(char *type, char *subtype, uint16_t comp, uint64_t number) {

	uint32_t offset = 0;
	if (strcasecmp(type, "pblock") == 0) {
		if (strcasecmp(subtype, "start") == 0) {
			offset = OFFnelblockStart;
		} else if (strcasecmp(subtype, "end") == 0) {
			offset = OFFnelblockEnd;
		} else if (strcasecmp(subtype, "step") == 0) {
			offset = OFFnelblockStep;
		} else if (strcasecmp(subtype, "size") == 0) {
			offset = OFFnelblockSize;
		} else {
			yyprintf("Unknown port block argument: %s", subtype);
			return -1;
		}
	} else {
			yyprintf("Unknown NAT argument: %s", type);
			return -1;
	}

	return NewElement(EXnatPortBlockID, offset, SIZEnelblockStart, number, comp, FUNC_NONE, NULLPtr);
	return -1;
} // End of AddNatPortBlocks

static int AddPayloadSSL(char *type, char *arg, char *opt) {
	if (strcasecmp(arg, "defined") == 0) {
		return NewElement(SSLindex, 0, 0, 0, CMP_EQ, FUNC_NONE, NULLPtr);
	} else if (strcasecmp(arg, "version") == 0) {
		if ( opt == NULL ){
			yyprintf("String %s is not a valid SSL/TLS version", arg);
			return -1;
		}
		unsigned int major, minor;
		if (sscanf(opt, "%1u.%1u", &major, &minor) != 2 || major > 3 || minor > 3 ) {
			yyprintf("String %s is not a valid SSL/TLS version", opt);
			return -1;
		}
		// if old SSL 2.0 or 3.0
		if (major > 1 && minor > 0){
			yyprintf("String %s is not a valid SSL/TLS version", opt);
			return -1;
		}
		uint16_t version = 0;
		if ( strcasecmp(type, "tls") == 0 ) {
			if (major > 1){
				yyprintf("String %s is not a valid TLS version", opt);
				return -1;
			}
			// TLS
			version = (0x03 << 8) | (minor + 1);
		} else {
			if (minor > 0){
				yyprintf("String %s is not a valid SSL version", opt);
				return -1;
			}
			// SSL
			version = major << 8;
		}
		return NewElement(SSLindex, OFFsslVersion, SIZEsslVersion, version, CMP_EQ, FUNC_NONE, NULLPtr);
	} else if (strcasecmp(arg, "sni") == 0) {
		if ( opt == NULL || strlen(opt) > 64 ) {
			yyprintf("Invalid string %s for SSL/TLS sni name", opt != NULL ? opt : "");
			return -1;
		}
		data_t data = {.dataPtr=strdup(opt)};
		return NewElement(SSLindex, OFFsslSNI, SIZEsslSNI, 0, CMP_SUBSTRING, FUNC_NONE, data);
	}
	yyprintf("String %s is not a valid SSL/TLS filter", arg);
	return -1;
} // End of AddPayloadSSL

static int AddPayloadJA3(char *type, char *arg, char *opt) {
	if (strcasecmp(arg, "defined") == 0) {
		return NewElement(JA3index, OFFja3String, SIZEja3String, 0, CMP_EQ, FUNC_NONE, NULLPtr);
	} else if (IsMD5(arg) == 0) {
		yyprintf("String %s is not a valid ja3 string", arg);
		return -1;
	}
	data_t data = {.dataPtr=strdup(arg)};
	return NewElement(JA3index, OFFja3String, SIZEja3String, 0, CMP_STRING, FUNC_NONE, data);
} // End of AddPayloadJA3

static int AddPayloadJA4(char *type, char *arg, char *opt) {
	if (strcasecmp(arg, "defined") == 0) {
		return NewElement(JA4index, OFFja4String, SIZEja3String, 0, CMP_EQ, FUNC_NONE, NULLPtr);
	} else if ( ja4Check(arg) == 0 ){
		yyprintf("String %s is not a valid ja4 string", arg);
		return -1;
	}
	data_t data = {.dataPtr=strdup(arg)};
	return NewElement(JA4index, OFFja4String, SIZEja4String, 0, CMP_STRING, FUNC_NONE, data);
} // End of AddPayloadJA4

static int AddPayload(char *type, char *arg, char *opt) {

	if (strcasecmp(type, "content") == 0) {
		data_t data = {.dataPtr = arg};
		return NewElement(EXinPayloadID, 0, 0, 0, CMP_PAYLOAD, FUNC_NONE, data);
	} else if (strcasecmp(type, "regex") == 0) {
		int err[2];
		char *regexArg = opt ? opt : "";
		srx_Context *program = srx_CreateExt(arg, strlen(arg), regexArg, err, NULL, NULL);
		if ( !program ) {
			yyprintf("failed to compile regex: %s", arg);
			return -1;
		}
		data_t data = {.dataPtr = program};
		return NewElement(EXinPayloadID, 0, 0, 0, CMP_REGEX, FUNC_NONE, data);
	} else if (strcasecmp(type, "ssl") == 0 || strcasecmp(type, "tls") == 0) {
		return AddPayloadSSL(type, arg, opt);
	} else if (strcasecmp(type, "ja3") == 0) {
		return AddPayloadJA3(type, arg, opt);
	} else if (strcasecmp(type, "ja4") == 0) {
		return AddPayloadJA4(type, arg, opt);
	} else if (strcasecmp(type, "ja4s") == 0) {
#ifdef BUILDJA4
		if ( ja4sCheck(arg) == 0 ){
			yyprintf("String %s is not a valid ja4s string", arg);
			return -1;
		}
		data_t data = {.dataPtr=strdup(arg)};
		return NewElement(JA4index, OFFja4String, SIZEja4sString, 0, CMP_STRING, FUNC_NONE, data);
#else
		yyprintf("ja4s code not enabled");
		return -1;
#endif
	} else {
		yyprintf("Unknown 'payload' argument: %s", type);
		return -1;
	}

	return -1;
} // End of AddPayload

static int AddGeo(direction_t direction, char *geo) {

	// geo => "geo CC" -> remove CC
	// lex rule guarantees 6 bytes - just test again
	geo += 4;
	if ( strlen(geo) != 2 ) {
			yyprintf("Geo country code legnth error");
			return -1;
	}

	data_t data = {.dataVal = direction};
	int ret = -1;
	uint64_t geoVal = toupper(geo[0]) + (toupper(geo[1]) << 8);
	switch (direction) {
		case DIR_SRC:
			ret = NewElement(EXlocal, OFFgeoSrcIP, SizeGEOloc, geoVal, CMP_GEO, FUNC_NONE, data);
			break;
		case DIR_DST:
			ret = NewElement(EXlocal, OFFgeoDstIP, SizeGEOloc, geoVal, CMP_GEO, FUNC_NONE, data);
			break;
		case DIR_SRC_NAT:
			ret = NewElement(EXlocal, OFFgeoSrcNatIP, SizeGEOloc, geoVal, CMP_GEO, FUNC_NONE, data);
			break;
		case DIR_DST_NAT:
			ret = NewElement(EXlocal, OFFgeoDstNatIP, SizeGEOloc, geoVal, CMP_GEO, FUNC_NONE, data);
			break;
		case DIR_SRC_TUN:
			ret = NewElement(EXlocal, OFFgeoSrcTunIP, SizeGEOloc, geoVal, CMP_GEO, FUNC_NONE, data);
			break;
		case DIR_DST_TUN:
			ret = NewElement(EXlocal, OFFgeoDstTunIP, SizeGEOloc, geoVal, CMP_GEO, FUNC_NONE, data);
			break;
		case DIR_UNSPEC: {
			data_t srcData = {.dataVal = DIR_SRC};
			data_t dstData = {.dataVal = DIR_DST};
			ret = Connect_OR(
				NewElement(EXlocal, OFFgeoSrcIP, SizeGEOloc, geoVal, CMP_GEO, FUNC_NONE, srcData),
				NewElement(EXlocal, OFFgeoDstIP, SizeGEOloc, geoVal, CMP_GEO, FUNC_NONE, dstData)
			);
			} break;
		case DIR_UNSPEC_NAT: {
			data_t srcData = {.dataVal = DIR_SRC_NAT};
			data_t dstData = {.dataVal = DIR_DST_NAT};
			ret = Connect_OR(
				NewElement(EXlocal, OFFgeoSrcNatIP, SizeGEOloc, geoVal, CMP_GEO, FUNC_NONE, srcData),
				NewElement(EXlocal, OFFgeoDstNatIP, SizeGEOloc, geoVal, CMP_GEO, FUNC_NONE, dstData)
			);
			} break;
		case DIR_UNSPEC_TUN: {
			data_t srcData = {.dataVal = DIR_SRC_TUN};
			data_t dstData = {.dataVal = DIR_DST_TUN};
			ret = Connect_OR(
				NewElement(EXlocal, OFFgeoSrcTunIP, SizeGEOloc, geoVal, CMP_GEO, FUNC_NONE, srcData),
				NewElement(EXlocal, OFFgeoDstTunIP, SizeGEOloc, geoVal, CMP_GEO, FUNC_NONE, dstData)
			);
			} break;
		default:
			yyprintf("Unknown Geo specifier");
	}

	return ret;
} // End of AddGeo

static int AddObservation(char *type, char *subType, uint16_t comp, uint64_t number) {

	if (strcasecmp(subType, "id") != 0) {
			yyprintf("Unknown observation specifier: %s", subType);
			return -1;
	}
	int ret = -1;
	if (strcasecmp(type, "domain") == 0) {
		ret =  NewElement(EXobservationID, OFFdomainID, SIZEdomainID, number, comp, FUNC_NONE, NULLPtr);
	} else if (strcasecmp(type, "point") == 0) {
		ret =  NewElement(EXobservationID, OFFpointID, SIZEpointID, number, comp, FUNC_NONE, NULLPtr);
	} else {
		yyprintf("Unknown observation specifier: %s", type);
	}

	return ret;
} // End of AddObservation

static int AddVRF(direction_t direction, uint16_t comp, uint64_t number) {

	int ret = -1;
	switch(direction) {
		case DIR_INGRESS:
			ret =  NewElement(EXvrfID, OFFingressVrf, SIZEingressVrf, number, comp, FUNC_NONE, NULLPtr);
			break;
		case DIR_EGRESS:
			ret =  NewElement(EXvrfID, OFFegressVrf, SIZEegressVrf, number, comp, FUNC_NONE, NULLPtr);
			break;
		default:
			yyprintf("Unknown vrf specifier");
	}

	return ret;
} // End of AddVRF

static int AddTimeSting(char *firstLast, uint16_t comp, char *timeString) {

	int ret = -1;
	uint64_t number = ParseTime8601(timeString);
	if ( number == 0 ) {
		yyprintf("Invalid ISO8601 time string: %s", timeString);
		return ret;
	}

	if ( strcasecmp(firstLast, "first") == 0 ) { // first seen
		ret =  NewElement(EXgenericFlowID, OFFmsecFirst, SIZEmsecFirst, number, comp, FUNC_NONE, NULLPtr);
	} else if ( strcasecmp(firstLast, "last") == 0 ) { // last seen
		ret =  NewElement(EXgenericFlowID, OFFmsecLast, SIZEmsecLast, number, comp, FUNC_NONE, NULLPtr);
	}	else { 
		yyprintf("Unexpected token: %s", timeString);
	}

	return ret;
} // End of AddTimeSting

static int AddPFString(char *type, char *arg) {

	int ret = -1;
	if (strcasecmp(type, "action") == 0) {
		int pfAction = pfActionNr(arg);
		if ( pfAction < 0 ) {
				yyprintf("Invalid pf action: %s", arg);
				printf("Possible pf action values: ");
				pfListActions();
			} else {
				ret = NewElement(EXpfinfoID, OFFpfAction, SIZEpfAction, pfAction, CMP_EQ, FUNC_NONE, NULLPtr);
			}
	} else if (strcasecmp(type, "reason") == 0) {
		int pfReason = pfReasonNr(arg);
			if ( pfReason < 0 ) {
				yyprintf("Invalid pf reason: %s", arg);
				printf("Possible pf reason values: ");
				pfListReasons();
			} else {
				ret = NewElement(EXpfinfoID, OFFpfReason, SIZEpfReason, pfReason, CMP_EQ, FUNC_NONE, NULLPtr);
			}
	} else if (strcasecmp(type, "dir") == 0) {
		int pfDir = strcasecmp(arg, "in") == 0 ? 1: 0;
		ret = NewElement(EXpfinfoID, OFFpfDir, SIZEpfDir, pfDir, CMP_EQ, FUNC_NONE, NULLPtr);
	} else if (strcasecmp(type, "interface") == 0) {
		data_t data = {.dataPtr=strdup(arg)};
		ret = NewElement(EXpfinfoID, OFFpfIfName, SIZEpfIfName, 0, CMP_STRING, FUNC_NONE, data);
	} else {
		yyprintf("Invalid pf argument: %s", type);
	}
	return ret;
} // End of AddPFString

static int AddPFNumber(char *type, uint16_t comp, uint64_t number) {

	int ret = -1;
	if (strcasecmp(type, "rule") == 0) {
		ret = NewElement(EXpfinfoID, OFFpfRuleNr, SIZEpfRuleNr, number, comp, FUNC_NONE, NULLPtr);
	} else {
		yyprintf("Invalid pf argument: %s", type);
	}

	return ret;
} // End of AddPFNumber

static int AddIP(direction_t direction, char *IPstr) {

	int ret = -1;

	// if it's a tor node check
	if (strcasecmp(IPstr, "tor") == 0 ) {
		switch ( direction ) {
		case DIR_SRC:
			ret = Connect_OR(
				NewElement(EXipv4FlowID, OFFsrc4Addr, SIZEsrc4Addr, 1, CMP_EQ, FUNC_TOR_LOOKUP, NULLPtr), 
				NewElement(EXipv6FlowID, OFFsrc6Addr, SIZEsrc6Addr, 1, CMP_EQ, FUNC_TOR_LOOKUP, NULLPtr)
			);
			break;
		case DIR_DST:
			ret = Connect_OR(
				NewElement(EXipv4FlowID, OFFdst4Addr, SIZEdst4Addr, 1, CMP_EQ, FUNC_TOR_LOOKUP, NULLPtr), 
				NewElement(EXipv6FlowID, OFFdst6Addr, SIZEdst6Addr, 1, CMP_EQ, FUNC_TOR_LOOKUP, NULLPtr)
			);
			break;
		case DIR_UNSPEC: {
			int src = Connect_OR(
				NewElement(EXipv4FlowID, OFFsrc4Addr, SIZEsrc4Addr, 1, CMP_EQ, FUNC_TOR_LOOKUP, NULLPtr), 
				NewElement(EXipv6FlowID, OFFsrc6Addr, SIZEsrc6Addr, 1, CMP_EQ, FUNC_TOR_LOOKUP, NULLPtr)
			);
			int dst = Connect_OR(
				NewElement(EXipv4FlowID, OFFdst4Addr, SIZEdst4Addr, 1, CMP_EQ, FUNC_TOR_LOOKUP, NULLPtr), 
				NewElement(EXipv6FlowID, OFFdst6Addr, SIZEdst6Addr, 1, CMP_EQ, FUNC_TOR_LOOKUP, NULLPtr)
			);
			ret = Connect_OR(src,dst); 
			} break;
		default:
			yyprintf("Invalid direction for tor lookup");
		}
		return ret;
	} 

	// else normal IP compare
	int lookupMode = STRICT_IP;
	switch ( direction ) {
			case DIR_SRC:
			case DIR_DST:
			case DIR_UNSPEC:
				lookupMode = ALLOW_LOOKUP;
				break;
			default:
				lookupMode = STRICT_IP;
	} // End of switch

	int numIP = parseIP(IPstr, ipStack, lookupMode);
	if ( numIP <= 0)  {
		yyprintf("Can not parse/lookup %s to an IP address", IPstr);
		return -1;
	}

	switch ( direction ) {
		case DIR_SRC:
		case DIR_DST:
		case DIR_SRC_NAT:
		case DIR_DST_NAT:
		case DIR_SRC_TUN:
		case DIR_DST_TUN:
		case DIR_NEXT:
		case BGP_NEXT:
		case SRC_ROUTER:
			ret = ChainHosts(ipStack, numIP, direction);
			break;
		case DIR_UNSPEC: {
			uint32_t src = ChainHosts(ipStack, numIP, DIR_SRC);
			uint32_t dst = ChainHosts(ipStack, numIP, DIR_DST);
			ret = Connect_OR(src, dst);
			} break;
		case DIR_UNSPEC_NAT: {
			uint32_t src = ChainHosts(ipStack, numIP, DIR_SRC_NAT);
			uint32_t dst = ChainHosts(ipStack, numIP, DIR_DST_NAT);
			ret = Connect_OR(src, dst);
			} break;
		case DIR_UNSPEC_TUN: {
			uint32_t src = ChainHosts(ipStack, numIP, DIR_SRC_TUN);
			uint32_t dst = ChainHosts(ipStack, numIP, DIR_DST_TUN);
			ret = Connect_OR(src, dst);
			} break;
		default:
			yyprintf("Unknown direction for IP address");
	} // End of switch

	return ret;
} // End of AddIP

static int AddNet(direction_t direction, char *IPstr, char *maskStr) {
	
	int numIP = parseIP(IPstr, ipStack, STRICT_IP);
	if (numIP <= 0)  {
		yyprintf("Can not parse/lookup %s to an IP address", IPstr);
		return -1;
	}

	ipStack_t	mask;
	numIP = parseIP(maskStr, &mask, STRICT_IP);
	if (numIP <= 0)  {
		yyprintf("Can not parse %s as IP mask", maskStr);
		return -1;
	}

	if (ipStack[0].af != PF_INET || mask.af != PF_INET) {
		yyprintf("Net address %s and netmask: %s must be IPv4", IPstr, maskStr);
		return -1;
	}

	data_t data = {.dataVal = mask.ipaddr[1]};

	int ret = -1;
	switch ( direction ) {
		case DIR_SRC:
		case DIR_DST:
		case DIR_SRC_NAT:
		case DIR_DST_NAT:
		case DIR_SRC_TUN:
		case DIR_DST_TUN:
		case DIR_NEXT:
		case BGP_NEXT:
		case SRC_ROUTER:
			ret = NewIPElement(&ipStack[0], direction, CMP_NET, &data);
			break;
		case DIR_UNSPEC: {
			uint32_t src = NewIPElement(&ipStack[0], DIR_SRC, CMP_NET, &data);
			uint32_t dst = NewIPElement(&ipStack[0], DIR_DST, CMP_NET, &data);
			ret = Connect_OR(src, dst);
			} break;
		case DIR_UNSPEC_NAT: {
			uint32_t src = NewIPElement(&ipStack[0], DIR_SRC_NAT, CMP_NET, &data);
			uint32_t dst = NewIPElement(&ipStack[0], DIR_DST_NAT, CMP_NET, &data);
			ret = Connect_OR(src, dst);
			} break;
		case DIR_UNSPEC_TUN: {
			uint32_t src = NewIPElement(&ipStack[0], DIR_SRC_TUN, CMP_NET, &data);
			uint32_t dst = NewIPElement(&ipStack[0], DIR_DST_TUN, CMP_NET, &data);
			ret = Connect_OR(src, dst);
			} break;
		default:
			yyprintf("Unknown direction for IP address");
	} // End of switch

	return ret;
} // End of AddNet

static int AddNetPrefix(direction_t direction, char *IPstr, uint64_t prefix) {
	int numIP = parseIP(IPstr, ipStack, STRICT_IP);
	if (numIP <= 0)  {
		yyprintf("Can not parse/lookup %s to an IP address", IPstr);
		return -1;
	}

	data_t data[2];
	if (ipStack[0].af == PF_INET) {
		// IPv4 
		if (prefix >32 ) {
			yyprintf("Prefix %" PRIu64 " out of range for IPv4 address", prefix);
			return -1;
		}
		data[0].dataVal = 0xffffffffffffffffLL << (32 - prefix);
	} else {
		// IPv6
		if (prefix >128 ) {
			yyprintf("Prefix %" PRIu64 " out of range for IPv6 address", prefix);
			return -1;
		}
		if ( prefix > 64 ) {
			data[0].dataVal = 0xffffffffffffffffLL;
			data[1].dataVal = 0xffffffffffffffffLL << (128 - prefix);
		} else {
			data[0].dataVal = 0xffffffffffffffffLL << (64 - prefix);
			data[1].dataVal = 0;
		}
	}

	int ret = -1;
	switch (direction) {
		case DIR_SRC:
		case DIR_DST:
		case DIR_SRC_NAT:
		case DIR_DST_NAT:
		case DIR_SRC_TUN:
		case DIR_DST_TUN:
		case DIR_NEXT:
		case BGP_NEXT:
		case SRC_ROUTER:
			ret = NewIPElement(&ipStack[0], direction, CMP_NET, data);
			break;
		case DIR_UNSPEC: {
			uint32_t src = NewIPElement(&ipStack[0], DIR_SRC, CMP_NET, data);
			uint32_t dst = NewIPElement(&ipStack[0], DIR_DST, CMP_NET, data);
			ret = Connect_OR(src, dst);
			} break;
		case DIR_UNSPEC_NAT: {
			uint32_t src = NewIPElement(&ipStack[0], DIR_SRC_NAT, CMP_NET, data);
			uint32_t dst = NewIPElement(&ipStack[0], DIR_DST_NAT, CMP_NET, data);
			ret = Connect_OR(src, dst);
			} break;
		case DIR_UNSPEC_TUN: {
			uint32_t src = NewIPElement(&ipStack[0], DIR_SRC_TUN, CMP_NET, data);
			uint32_t dst = NewIPElement(&ipStack[0], DIR_DST_TUN, CMP_NET, data);
			ret = Connect_OR(src, dst);
			} break;
		default:
			yyprintf("Unknown direction for IP address");
	} // End of switch

	return ret;
} // End of AddNetPrefix

static int AddIPlist(direction_t direction, void *IPlist) {
	int ret = -1;
	data_t IPlistData = {IPlist};
	switch ( direction ) {
		case DIR_SRC:
			ret = Connect_OR(
				NewElement(EXipv4FlowID, OFFsrc4Addr, SIZEsrc4Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData), 
				NewElement(EXipv6FlowID, OFFsrc6Addr, SIZEsrc6Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData)
			);
			break;
		case DIR_DST:
			ret = Connect_OR(
				NewElement(EXipv4FlowID, OFFdst4Addr, SIZEdst4Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData), 
				NewElement(EXipv6FlowID, OFFdst6Addr, SIZEdst6Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData)
			);
			break;
		case DIR_SRC_NAT:
			ret = Connect_OR(
				NewElement(EXnatXlateIPv4ID, OFFxlateSrc4Addr, SIZExlateSrc4Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData), 
				NewElement(EXnatXlateIPv6ID, OFFxlateSrc6Addr, SIZExlateSrc6Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData)
			);
			break;
		case DIR_DST_NAT:
			ret = Connect_OR(
				NewElement(EXnatXlateIPv4ID, OFFxlateDst4Addr, SIZExlateDst4Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData), 
				NewElement(EXnatXlateIPv6ID, OFFxlateDst6Addr, SIZExlateDst6Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData)
			);
			break;
		case DIR_SRC_TUN:
			ret = Connect_OR(
				NewElement(EXtunIPv4ID, OFFtunSrc4Addr, SIZEtunSrc4Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData), 
				NewElement(EXtunIPv6ID, OFFtunSrc6Addr, SIZEtunSrc6Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData)
			);
			break;
		case DIR_DST_TUN:
			ret = Connect_OR(
				NewElement(EXtunIPv4ID, OFFtunDst4Addr, SIZEtunDst4Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData), 
				NewElement(EXtunIPv6ID, OFFtunDst6Addr, SIZEtunDst6Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData)
			);
			break;
		case DIR_NEXT:
			ret = Connect_OR(
				NewElement(EXipNextHopV4ID, OFFNextHopV4IP, SIZENextHopV4IP, 0, CMP_IPLIST, FUNC_NONE, IPlistData), 
				NewElement(EXipNextHopV6ID, OFFNextHopV6IP, SIZENextHopV6IP, 0, CMP_IPLIST, FUNC_NONE, IPlistData)
			);
			break;
		case DIR_UNSPEC: {
			int v4 = Connect_OR(
				NewElement(EXipv4FlowID, OFFsrc4Addr, SIZEsrc4Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData), 
				NewElement(EXipv4FlowID, OFFdst4Addr, SIZEdst4Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData) 
			);
			int v6 = Connect_OR(
				NewElement(EXipv6FlowID, OFFsrc6Addr, SIZEsrc6Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData),
				NewElement(EXipv6FlowID, OFFdst6Addr, SIZEdst6Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData)
			);
			ret = Connect_OR(v4, v6);
		} break;
		case DIR_UNSPEC_NAT: {
			int v4 = Connect_OR(
				NewElement(EXnatXlateIPv4ID, OFFxlateSrc4Addr, SIZExlateSrc4Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData), 
				NewElement(EXnatXlateIPv4ID, OFFxlateDst4Addr, SIZExlateDst4Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData) 
			);
			int v6 = Connect_OR(
				NewElement(EXnatXlateIPv6ID, OFFxlateSrc6Addr, SIZExlateSrc6Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData),
				NewElement(EXnatXlateIPv6ID, OFFxlateDst6Addr, SIZExlateDst6Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData)
			);
			ret = Connect_OR(v4, v6);
		} break;
		case DIR_UNSPEC_TUN: {
			int v4 = Connect_OR(
				NewElement(EXtunIPv4ID, OFFtunSrc4Addr, SIZEtunSrc4Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData), 
				NewElement(EXtunIPv4ID, OFFtunDst4Addr, SIZEtunDst4Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData)
			);
			int v6 = Connect_OR(
				NewElement(EXtunIPv6ID, OFFtunSrc6Addr, SIZEtunSrc6Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData),
				NewElement(EXtunIPv6ID, OFFtunDst6Addr, SIZEtunDst6Addr, 0, CMP_IPLIST, FUNC_NONE, IPlistData)
			);
			ret = Connect_OR(v4, v6);
		} break;
		default:
			yyprintf("Unknown direction for IP list");
	}

	return ret;
} // AddIPlist

static struct IPListNode *mkNode(ipStack_t ipStack, int64_t prefix) {

	struct IPListNode *node = malloc(sizeof(struct IPListNode));
	if (node == NULL) {
		yyprintf("malloc() error in %s line %d: %s", __FILE__, __LINE__, strerror(errno));
		return NULL;
	}

	node->ip[0] = ipStack.ipaddr[0];
	node->ip[1] = ipStack.ipaddr[1];
	node->mask[0] = 0xffffffffffffffffLL;
	node->mask[1] = 0xffffffffffffffffLL;

	if ( prefix > 0 ) {
		if (ipStack.af == PF_INET) {
		// IPv4 
			if (prefix >32 ) {
				yyprintf("Prefix %" PRIu64 " out of range for IPv4 address", prefix);
				return NULL;
			}
			node->mask[0] = 0;
			node->mask[1] = 0xffffffffffffffffLL << (32 - prefix);
		} else {
			// IPv6
			if (prefix >128 ) {
				yyprintf("Prefix %" PRIu64 " out of range for IPv6 address", prefix);
				return NULL;
			}
			if ( prefix > 64 ) {
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL << (128 - prefix);
			} else {
				node->mask[0] = 0xffffffffffffffffLL << (64 - prefix);
				node->mask[1] = 0;
			}
		}
	}
	return node;
}

static void *NewIplist(char *IPstr, int prefix) {
	IPlist_t *root = malloc(sizeof(IPlist_t));
	if (root == NULL) {
		yyprintf("malloc() error in %s line %d: %s", __FILE__, __LINE__, strerror(errno));
		return NULL;
	}
	RB_INIT(root);

	int numIP = parseIP(IPstr, ipStack, ALLOW_LOOKUP);
	if ( numIP <= 0 ) {
		yyprintf("Can not parse/resolve %s to an IP address", IPstr);
		free(root);
		return NULL;
	}
		
	for (int i=0; i<numIP; i++ ) {
	  struct IPListNode *node = mkNode(ipStack[i], prefix);
		if ( node ) {
			RB_INSERT(IPtree, root, node);
		} else {
			free(root);
			return NULL;
		}
	}

	return root;
} // End of NewIPlist

static int InsertIPlist(void *IPlist, char *IPstr, int64_t prefix) {
	int numIP = parseIP(IPstr, ipStack, ALLOW_LOOKUP);
	if ( numIP <= 0 ) {
		// ret == - 2 means lookup failure
		yyprintf("Can not parse/resolve %s to an IP address", IPstr);
		return 0;
	}

	for (int i=0; i<numIP; i++ ) {
		struct IPListNode *node = mkNode(ipStack[i], prefix);
		if ( node ) {
			RB_INSERT(IPtree, (IPlist_t *)IPlist, node);
		} else {
			return 0;
		}
	}
	return 1;
} // End of InsertIPlist

static void *NewU64list(uint64_t num) {
	U64List_t *root = malloc(sizeof(U64List_t));
	if (root == NULL) {
		yyprintf("malloc() error in %s line %d: %s", __FILE__, __LINE__, strerror(errno));
		return NULL;
	}
	RB_INIT(root);

  struct U64ListNode *node;
	if ((node = malloc(sizeof(struct U64ListNode))) == NULL) {
		yyprintf("malloc() error in %s line %d: %s", __FILE__, __LINE__, strerror(errno));
		free(root);
		return NULL;
	}
	node->value = num;
	RB_INSERT(U64tree, root, node);

	return root;
} // End of NewU64list

static int InsertU64list(void *U64list, uint64_t num) {
	
	struct U64ListNode *node;
	if ((node = malloc(sizeof(struct U64ListNode))) == NULL) {
		yyprintf("malloc() error in %s line %d: %s", __FILE__, __LINE__, strerror(errno));
		return 0;
	}
	node->value = num;
	RB_INSERT(U64tree, U64list, node);

	return 1;
} // End of InsertU64list

static int AddPortList(direction_t direction, void *U64List) {

	// check, that each element is a valid port number
	struct U64ListNode *node;
	RB_FOREACH(node, U64tree, (U64List_t *)U64List) {
		if ( node->value > 65535 ) {
			yyprintf("Port: %" PRIu64 " outside of range 0..65535", node->value);
			return -1;
		}
	}

	data_t U64ListPtr = {U64List};
	int ret = -1;
  switch ( direction ) {
	  case DIR_SRC:
		  ret = NewElement(EXgenericFlowID, OFFsrcPort, SIZEsrcPort, 0, CMP_U64LIST, FUNC_NONE, U64ListPtr);
		  break;
	  case DIR_DST:
		  ret = NewElement(EXgenericFlowID, OFFdstPort, SIZEdstPort, 0, CMP_U64LIST, FUNC_NONE, U64ListPtr);
		  break;
	  case DIR_UNSPEC:
		  ret = Connect_OR(
			  NewElement(EXgenericFlowID, OFFsrcPort, SIZEsrcPort, 0, CMP_U64LIST, FUNC_NONE, U64ListPtr),
				NewElement(EXgenericFlowID, OFFdstPort, SIZEdstPort, 0, CMP_U64LIST, FUNC_NONE, U64ListPtr)
		  );
		  break;
		case DIR_SRC_NAT:
		  ret = NewElement(EXnatXlatePortID, OFFxlateSrcPort, SIZExlateSrcPort, 0, CMP_U64LIST, FUNC_NONE, U64ListPtr);
		  break;
	  case DIR_DST_NAT:
		  ret = NewElement(EXnatXlatePortID, OFFxlateDstPort, SIZExlateDstPort, 0, CMP_U64LIST, FUNC_NONE, U64ListPtr);
		  break;
	  case DIR_UNSPEC_NAT:
		  ret = Connect_OR(
		  	NewElement(EXnatXlatePortID, OFFxlateSrcPort, SIZExlateSrcPort, 0, CMP_U64LIST, FUNC_NONE, U64ListPtr),
		  	NewElement(EXnatXlatePortID, OFFxlateDstPort, SIZExlateDstPort, 0, CMP_U64LIST, FUNC_NONE, U64ListPtr )
		  );
		  break;
	  default:
		  yyprintf("Unknown direction");
  } // End switch

	return ret;
} // AddPortList

static int AddASList(direction_t direction, void *U64List) {

	// check, that each element is a valid AS number
	struct U64ListNode *node;
	RB_FOREACH(node, U64tree, (U64List_t *)U64List) {
		if ( node->value > 0xFFFFFFFFLL ) {
			yyprintf("AS: %" PRIu64 " outside of range 32bit", node->value);
			return -1;
		}
	}

	data_t U64ListPtr = {U64List};
	int ret = -1;
  switch ( direction ) {
	  case DIR_SRC:
		  ret = NewElement(EXasRoutingID, OFFsrcAS, SIZEsrcAS, 0, CMP_U64LIST, FUNC_NONE, U64ListPtr);
		  break;
	  case DIR_DST:
		  ret = NewElement(EXasRoutingID, OFFdstAS, SIZEdstAS, 0, CMP_U64LIST, FUNC_NONE, U64ListPtr);
		  break;
	  case DIR_UNSPEC:
		  ret = Connect_OR(
			  NewElement(EXasRoutingID, OFFsrcAS, SIZEsrcAS, 0, CMP_U64LIST, FUNC_NONE, U64ListPtr),
			  NewElement(EXasRoutingID, OFFdstAS, SIZEdstAS, 0, CMP_U64LIST, FUNC_NONE, U64ListPtr)
		  );
		  break;
		case DIR_NEXT:
		  ret = NewElement(EXasAdjacentID, OFFnextAdjacentAS, SIZEnextAdjacentAS, 0, CMP_U64LIST, FUNC_NONE, U64ListPtr);
			break;
		case DIR_PREV:
		  ret = NewElement(EXasAdjacentID, OFFprevAdjacentAS, SIZEprevAdjacentAS, 0, CMP_U64LIST, FUNC_NONE, U64ListPtr);
		  break;
	  default:
			yyprintf("Unknown direction");
  } // End of switch

	return ret;
} // AddASList

static int AddInterfaceNumber(direction_t direction, uint64_t num) {
	if ( num > 0xffffffffLL ) {
		yyprintf("Interface number out of range 0..2^32");
		return -1;
	}

	int ret = -1;
	switch ( direction ) {
		case DIR_UNSPEC:
			ret = Connect_OR(
				NewElement(EXflowMiscID, OFFinput, SIZEinput, num, CMP_EQ, FUNC_NONE, NULLPtr),
				NewElement(EXflowMiscID, OFFoutput, SIZEoutput, num, CMP_EQ, FUNC_NONE, NULLPtr)
			);
			break;
		case DIR_IN: 
			ret = NewElement(EXflowMiscID, OFFinput, SIZEinput, num, CMP_EQ, FUNC_NONE, NULLPtr);
			break;
		case DIR_OUT: 
			ret = NewElement(EXflowMiscID, OFFoutput, SIZEoutput, num, CMP_EQ, FUNC_NONE, NULLPtr);
			break;
		default:
			yyprintf("Unknown interface direction");
	} // End of switch

	return ret;
} // End of AddInterfaceNumber

static int AddVlanNumber(direction_t direction, uint64_t num) {
	if ( num > 0xffffffffLL ) {
		yyprintf("Vlan number out of range 32bit");
		return -1;
	}

	int ret = -1;
	switch ( direction ) {
		case DIR_UNSPEC: {
			int src = Connect_OR(
			  NewElement(EXvLanID, OFFsrcVlan, SIZEsrcVlan, num, CMP_EQ, FUNC_NONE, NULLPtr),
			  NewElement(EXlayer2ID, OFFvlanID, SIZEvlanID, num, CMP_EQ, FUNC_NONE, NULLPtr)
			);
			int dst = Connect_OR(
			  NewElement(EXvLanID, OFFdstVlan, SIZEdstVlan, num, CMP_EQ, FUNC_NONE, NULLPtr),
			  NewElement(EXlayer2ID, OFFpostVlanID, SIZEpostVlanID, num, CMP_EQ, FUNC_NONE, NULLPtr)
			);
			ret = Connect_OR(src,dst);
			} break;
		case DIR_SRC: 
			ret = Connect_OR(
			  NewElement(EXvLanID, OFFsrcVlan, SIZEsrcVlan, num, CMP_EQ, FUNC_NONE, NULLPtr),
			  NewElement(EXlayer2ID, OFFvlanID, SIZEvlanID, num, CMP_EQ, FUNC_NONE, NULLPtr)
			);
			break;
		case DIR_DST: 
			ret = Connect_OR(
			  NewElement(EXvLanID, OFFdstVlan, SIZEdstVlan, num, CMP_EQ, FUNC_NONE, NULLPtr),
			  NewElement(EXlayer2ID, OFFpostVlanID, SIZEpostVlanID, num, CMP_EQ, FUNC_NONE, NULLPtr)
			);
			break;
		default:
			yyprintf("Unknown vlan direction");
	} // End of switch

	return ret;
} // End of AddVlanNumber

static int AddAsNumber(direction_t direction, uint16_t comp, uint64_t as) {
	if (as > UINT32_MAX ) {
		yyprintf("AS number of range");
		return -1;
  }

	int ret = -1;
  switch ( direction ) {
	  case DIR_SRC:
		  ret = NewElement(EXasRoutingID, OFFsrcAS, SIZEsrcAS, as, comp, FUNC_MMAS_LOOKUP, (data_t){.dataVal = OFFsrcAS});
		  break;
	  case DIR_DST:
		  ret = NewElement(EXasRoutingID, OFFdstAS, SIZEdstAS, as, comp, FUNC_MMAS_LOOKUP , (data_t){.dataVal = OFFdstAS});
		  break;
	  case DIR_UNSPEC:
		  ret = Connect_OR(
			  NewElement(EXasRoutingID, OFFsrcAS, SIZEsrcAS, as, comp, FUNC_MMAS_LOOKUP, (data_t){.dataVal = OFFsrcAS}),
			  NewElement(EXasRoutingID, OFFdstAS, SIZEdstAS, as, comp, FUNC_MMAS_LOOKUP ,(data_t){.dataVal = OFFdstAS} )
		  );
			break;
		case DIR_NEXT:
		  ret = NewElement(EXasAdjacentID, OFFnextAdjacentAS, SIZEnextAdjacentAS, as, comp, FUNC_MMAS_LOOKUP, NULLPtr);
			break;
		case DIR_PREV:
		  ret = NewElement(EXasAdjacentID, OFFprevAdjacentAS, SIZEprevAdjacentAS, as, comp, FUNC_MMAS_LOOKUP, NULLPtr);
		  break;
	  default:
			yyprintf("Unknown direction");
  } // End of switch

	return ret;
} // End of AddAsNumber

static int AddMaskNumber(direction_t direction, uint64_t num) {
	if ( num > 255 ) {
		yyprintf("Mask %" PRIu64 " out of range 0..255", num);
		return -1;
	}

	int ret = -1;
	switch ( direction ) {
		case DIR_UNSPEC:
			ret = Connect_OR(
				NewElement(EXflowMiscID, OFFsrcMask, SIZEsrcMask, num, CMP_EQ, FUNC_NONE, NULLPtr),
				NewElement(EXflowMiscID, OFFdstMask, SIZEdstMask, num, CMP_EQ, FUNC_NONE, NULLPtr)
			);
			break;
		case DIR_SRC: 
			ret = NewElement(EXflowMiscID, OFFsrcMask, SIZEsrcMask, num, CMP_EQ, FUNC_NONE, NULLPtr);
			break;
		case DIR_DST: 
			ret = NewElement(EXflowMiscID, OFFdstMask, SIZEdstMask, num, CMP_EQ, FUNC_NONE, NULLPtr);
			break;
		default:
			yyprintf("Invalid direction for mask");
	} // End of switch

	return ret;
} // End of AddMaskNumber

static int AddFlowDir(direction_t direction, int64_t dirNum) {

	int ret = -1;
	switch (direction) {
		case DIR_INGRESS:
	  	ret = NewElement(EXflowMiscID, OFFdir, SIZEdir, 0, CMP_EQ, FUNC_NONE, NULLPtr);
			break;
		case DIR_EGRESS:
	  	ret = NewElement(EXflowMiscID, OFFdir, SIZEdir, 1, CMP_EQ, FUNC_NONE, NULLPtr);
			break;
		case DIR_UNSPEC:
			if (dirNum != 0 && dirNum != 1) {
	 			yyprintf("Unknown flowdir: %" PRIi64, dirNum);
			} else {
	  		ret = NewElement(EXflowMiscID, OFFdir, SIZEdir, dirNum, CMP_EQ, FUNC_NONE, NULLPtr);
			}
			break;
		default:
	 			yyprintf("Unknown flowdir");
	}

	return ret;
} // End of AddFlowDirString
